#!/usr/bin/perl
use Mysql;
use Socket;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
$encline=crypt($data{password},$data{password});
$destination=$data{method};
$destination="genset" unless ($destination);

&$destination if ($admpass eq $encline);
&closedb;
print "HTTP/1.0 302 Found\n" if ($sysid eq "Windows");
print "Location: $cworld/admin.html\n\n";

sub category
{
$selected{category}="selected";
$sth=$dbh->query("LOCK TABLES cw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_categories ORDER BY category");
while(($num,$cat,$desc)=$sth->fetchrow)
{
	$cat=~s/APOSTROPHH/'/g;
	$desc=~s/APOSTROPHH/'/g;
	$desc=~s/\n/<br>/g;
	push(@res,"<tr><td bgcolor=yellow><font color=black><b>$cat</b></font></td><td align=center bgcolor=yellow><a href=\"$cgi/cwadmin.pl?method=remcat&num=$num&password=$data{password}\"><font size=2 color=black>Remove</font></a></td></tr><tr><td colspan=2><font size=1>$desc</font></td></tr>\n");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if (scalar(@res)==0)
{
	push(@res,"<tr><td>No categories was found</td></tr>\n");
}
&closedb;
&methods;
open (F,"<$cwpath/template/category.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remcat
{
$selected{category}="selected";
&closedb;
&methods;
open (F,"<$cwpath/template/rcconfirm.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub remcat_c
{
$sth=$dbh->query("LOCK TABLES cw_coupons READ") if ($locktables);
$sth=$dbh->query("SELECT cpid FROM cw_coupons WHERE caid=$data{num}");
@cpid=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_stats WRITE,cw_books WRITE") if ($locktables);
foreach(@cpid)
{
	$sth=$dbh->query("DELETE FROM cw_stats WHERE cpid=$_");
	$sth=$dbh->query("DELETE FROM cw_books WHERE cpid=$_");
	unlink("$cwpath/coupons/$_.jpg");
	unlink("$cwpath/coupons/$_.gif");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM cw_coupons WHERE caid=$data{num}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_categories WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM cw_categories WHERE caid=$data{num}");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&category;
}
sub addcat
{
$data{cat}=~s/'/APOSTROPHH/g;
$data{desc}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES cw_categories WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO cw_categories (category,descr) VALUES ('$data{cat}','$data{desc}')");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&category;
}
sub stats
{
$selected{stats}="selected";
$gqt=0;
$goh=0;
$grec=0;
$sth=$dbh->query("LOCK TABLES cw_categories,cw_coupons READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category FROM cw_categories ORDER BY category");
while(($num,$cat)=$sth->fetchrow)
{
	$qtc=0;
	$ohc=0;
	$total=0;
	$cat=~s/APOSTROPHH/'/g;
	$sthx=$dbh->query("SELECT COUNT(*),SUM(qty),SUM(taken) FROM cw_coupons WHERE caid=$num");
	($total,$qtc,$ohc)=$sthx->fetchrow;
	$sthx="";
	$qtc=0 unless ($qtc);
	$ohc=0 unless ($ohc);
	push(@res,"<tr><td colspan=2 bgcolor=yellow><b><font color=black>$cat category stats</font></b></td></tr><tr><td><font size=2>Total coupon records</font></td><td><font size=2>$total</font></td></tr><tr><td><font size=2>Total coupons</font></td><td><font size=2>$qtc</font></td></tr><tr><td><font size=2>Coupons On-Hand</font></td><td><font size=2>$ohc</font></td></tr>\n");
	$gqt+=$qtc;
	$goh+=$ohc;
	$grec+=$total;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
push(@res,"<tr><td colspan=2 bgcolor=yellow><b><font color=black>Total stats</font></b></td></tr><tr><td><font size=2>Total records</font></td><td><font size=2>$grec</font></td></tr><tr><td><font size=2>Total coupons</font></td><td><font size=2>$gqt</font></td></tr><tr><td><font size=2>Coupons On-Hand</font></td><td><font size=2>$goh</font></td></tr>\n");
&closedb;
&methods;
open (F,"<$cwpath/template/genstats.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub maillist
{
$selected{maillist}="selected";
&closedb;
&methods;
open (F,"<$cwpath/template/maillist.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub sendmail
{
$selected{maillist}="selected";
if ($data{recipient} eq "owners")
{
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM cw_agencies");
@userdat=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
else
{
$sth=$dbh->query("LOCK TABLES cw_visitors READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM cw_visitors");
@userdat=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT header,footer FROM cw_settings");
($header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$header=~s/APOSTROPHH/'/g;
$footer=~s/APOSTROPHH/'/g;
$count=0;
if (@userdat>0)
{
	foreach(@userdat)
	{
		next if ($_ eq "");
		$count++;
		open (MAIL,"|$progmail");
		print MAIL "To: $uemail\n";
		print MAIL "From: $email ($owntitle)\n";
		print MAIL "Subject: $data{subject}\n\n";
		print MAIL $header;
		print MAIL "$data{body}\n\n";
		print MAIL $footer;
		print MAIL "\n.\n";
		close (MAIL);
	}
}
&closedb;
&methods;
open (F,"<$cwpath/template/mailres.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub downmail
{
$selected{maillist}="selected";
if ($data{recipient} eq "owners")
{
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM cw_agencies");
@userdat=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
else
{
$sth=$dbh->query("LOCK TABLES cw_visitors READ") if ($locktables);
$sth=$dbh->query("SELECT email FROM cw_visitors");
@userdat=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-disposition: filename=\"cw_maillist_$data{recipient}.mls\"; \n";
print "content-type: application/maillist\n\n";
foreach(@userdat)
{
	print "$_\n";
}
exit;
}
sub genset
{
$selected{genset}="selected";
open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT header,footer,invoice FROM cw_settings");
($header,$footer,$invoice)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$header=~s/APOSTROPHH/'/g;
$footer=~s/APOSTROPHH/'/g;
$invoice=~s/APOSTROPHH/'/g;
&closedb;
&methods;
open (F,"<$cwpath/template/settings.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub mdgenset
{
if ($data{admpass} ne "")
{
	$admpass=crypt($data{admpass},$data{admpass});
	$data{password}=$data{admpass};
}
open (F,">cworld.cfg");
print F qq~#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

\$cwpath="$data{cwpath}";
\$backuppath="$data{backuppath}";
\$cgi="$data{cgi}";
\$cworld="$data{cworld}";
\$sysid="$data{sysid}";
\$progmail="$data{progmail}";
\$email='$data{email}';
\$furl="$data{furl}";
\%calendar=('Jan','31','Feb','28','Mar','31','Apr','30','May','31','Jun','30','Jul','31','Aug','31','Sep','30','Oct','31','Nov','30','Dec','31');
\%cal=('Jan','01','Feb','02','Mar','03','Apr','04','May','05','Jun','06','Jul','07','Aug','08','Sep','09','Oct','10','Nov','11','Dec','12');
\@cal=('Dummy','January','February','March','April','May','June','July','August','September','October','November','December');
\$admpass="$admpass";
\$owntitle="$data{owntitle}";
\$cool=$data{cool};
\$nrpp=$data{nrpp};
\$nlim=$data{nlim};
\$logowidth=$data{logowidth};
\$payperday=$data{payperday};
\$tax=$data{tax};
\$currency="$data{currency}";
\$autoaccept=$data{autoaccept};
\$ccpayment=$data{ccpayment};
\$cclib="$data{cclib}";
\$mysqlhost="$data{mysqlhost}";
\$mysqldb="$data{mysqldb}";
\$mysqllogin="$data{mysqllogin}";
\$mysqlpassword="$data{mysqlpassword}";
\$locktables=$data{locktables};
\$license="$license";
\$usecm=$data{usecm};
\$maxwidth=$data{maxwidth};
\$maxheight=$data{maxheight};
\$clipart_th_width=$data{clipart_th_width};
\$tmpl_th_width=$data{tmpl_th_width};
\$couponmode=$data{couponmode};
\$paypal_user='$data{paypal_user}';
\$paypal_item="$data{paypal_item}";
\$paypal_currency="$data{paypal_currency}";
~;
close(F);
&genset;
}
sub mdfoot
{
$data{footer}=~s/\r//g;
$data{footer}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES cw_settings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE cw_settings SET footer='$data{footer}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub mdhead
{
$data{header}=~s/\r//g;
$data{header}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES cw_settings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE cw_settings SET header='$data{header}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub mdinvoice
{
$data{invoice}=~s/\r//g;
$data{invoice}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES cw_settings WRITE") if ($locktables);
$sth=$dbh->query("UPDATE cw_settings SET invoice='$data{invoice}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&genset;
}
sub agency
{
$selected{agency}="selected";
&closedb;
&methods;
open (F,"<$cwpath/template/agency.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub aglist
{
$selected{agency}="selected";
$type=$data{type};
$selectede{$type}="selected";
$sth=$dbh->query("LOCK TABLES cw_countries READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_countries ORDER BY country");
while(($coid,$coname)=$sth->fetchrow)
{
	$coname=~s/APOSTROPHH/'/g;
	$country[$coid]=$coname;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($data{type} eq "all")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT aid,status,email,password,agency,address,city,state,zip,phone,URL,country,price FROM cw_agencies ORDER BY agency");
	while(($aid,$status,$email,$password,$agency,$address,$city,$state,$zip,$phone,$url,$country,$realpayperday)=$sth->fetchrow)
	{
		$address=~s/APOSTROPHH/'/g;
		$city=~s/APOSTROPHH/'/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a></b></td></tr><tr><td><font size=2>Full address:</font></td><td><font size=2>$address, $city, $zip, $state, $country[$country]</font></td></tr><tr><td><font size=2>Phone:</font></td><td><font size=2>$phone</font></td></tr><tr><td><font size=2>Contact info:</font></td><td><font size=2><a href="$url" target="_blank">$url</a>, <a href="mailto:$email">$email</a></font></td></tr><tr><td><font size=2>Service price (per day):</font></td><td><font size=2>$realpayperday $currency</font></td></tr>\n~;
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "napp")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT aid,status,email,password,agency,address,city,state,zip,phone,URL,country,price FROM cw_agencies WHERE status=0 ORDER BY agency");
	while(($aid,$status,$email,$password,$agency,$address,$city,$state,$zip,$phone,$url,$country,$realpayperday)=$sth->fetchrow)
	{
		$address=~s/APOSTROPHH/'/g;
		$city=~s/APOSTROPHH/'/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a></b></td></tr><tr><td><font size=2>Full address:</font></td><td><font size=2>$address, $city, $zip, $state, $country[$country]</font></td></tr><tr><td><font size=2>Phone:</font></td><td><font size=2>$phone</font></td></tr><tr><td><font size=2>Contact info:</font></td><td><font size=2><a href="$url" target="_blank">$url</a>, <a href="mailto:$email">$email</a></font></td></tr><tr><td><font size=2>Service price (per day):</font></td><td><font size=2>$realpayperday $currency</font></td></tr><tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agapp"><input type="hidden" name="type" value="$type"><input type="hidden" name="aid" value="$aid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdel"><input type="hidden" name="type" value="$type"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "app")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT aid,status,email,password,agency,address,city,state,zip,phone,URL,country,price FROM cw_agencies WHERE status=1 ORDER BY agency");
	while(($aid,$status,$email,$password,$agency,$address,$city,$state,$zip,$phone,$url,$country,$realpayperday)=$sth->fetchrow)
	{
		$address=~s/APOSTROPHH/'/g;
		$city=~s/APOSTROPHH/'/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a></b></td></tr><tr><td><font size=2>Full address:</font></td><td><font size=2>$address, $city, $zip, $state, $country[$country]</font></td></tr><tr><td><font size=2>Phone:</font></td><td><font size=2>$phone</font></td></tr><tr><td><font size=2>Contact info:</font></td><td><font size=2><a href="$url" target="_blank">$url</a>, <a href="mailto:$email">$email</a></font></td></tr><tr><td><font size=2>Service price (per day):</font></td><td><font size=2>$realpayperday $currency</font></td></tr><tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdis"><input type="hidden" name="type" value="$type"><input type="hidden" name="aid" value="$aid"><input type=submit value="Disable"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdel"><input type="hidden" name="type" value="$type"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "dis")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT aid,status,email,password,agency,address,city,state,zip,phone,URL,country,price FROM cw_agencies WHERE status=2 ORDER BY agency");
	while(($aid,$status,$email,$password,$agency,$address,$city,$state,$zip,$phone,$url,$country,$realpayperday)=$sth->fetchrow)
	{
		$address=~s/APOSTROPHH/'/g;
		$city=~s/APOSTROPHH/'/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a></b></td></tr><tr><td><font size=2>Full address:</font></td><td><font size=2>$address, $city, $zip, $state, $country[$country]</font></td></tr><tr><td><font size=2>Phone:</font></td><td><font size=2>$phone</font></td></tr><tr><td><font size=2>Contact info:</font></td><td><font size=2><a href="$url" target="_blank">$url</a>, <a href="mailto:$email">$email</a></font></td></tr><tr><td><font size=2>Service price (per day):</font></td><td><font size=2>$realpayperday $currency</font></td></tr><tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agena"><input type="hidden" name="type" value="$type"><input type="hidden" name="aid" value="$aid"><input type=submit value="Enable"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdel"><input type="hidden" name="type" value="$type"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&agency;
}
sub agapp
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET status=1 WHERE aid=$data{aid}");
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency is approved\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is approved. Now you can login to members section from:\n";
	print MAIL "$cworld/members.html\n";
	print MAIL "Login: $uemail\n";
	print MAIL "Password: $pass\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&aglist;
}
sub agdis
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET status=2 WHERE aid=$data{aid}");
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency account is disabled\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is temporary disabled. Please, contact us to solve this problem.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&aglist;
}
sub agena
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET status=1 WHERE aid=$data{aid}");
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency account is enabled\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is enabled now.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&aglist;
}
sub agdel
{
if ($data{aid})
{
	$selected{agency}="selected";
	&closedb;
	&methods;
	open (F,"<$cwpath/template/agrconfirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&aglist;
}
sub agdel_c
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_companies READ") if ($locktables);
	$sth=$dbh->query("SELECT cid FROM cw_companies WHERE aid=$data{aid}");
	@cid=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
	foreach(@cid)
	{
		$sth=$dbh->query("SELECT cpid FROM cw_coupons WHERE cid=$_");
		@temp=$sth->fetchcol;
		@cpid=(@cpid,@temp);
		$sth=$dbh->query("DELETE FROM cw_coupons WHERE cid=$_");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_stats WRITE,cw_books WRITE") if ($locktables);
	foreach(@cpid)
	{
		$sth=$dbh->query("DELETE FROM cw_stats WHERE cpid=$_");
		$sth=$dbh->query("DELETE FROM cw_books WHERE cpid=$_");
		unlink("$cwpath/coupons/$_.gif");
		unlink("$cwpath/coupons/$_.jpg");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_companies WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM cw_companies WHERE aid=$data{aid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("DELETE FROM cw_agencies WHERE aid=$data{aid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency account is removed\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is removed from our system.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&aglist;
}
sub agsearch
{
$selected{agency}="selected";
$type=$data{type};
$selectede{$type}="selected";
$type=$data{where};
$selectedee{$type}="selected";
$sth=$dbh->query("LOCK TABLES cw_countries READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_countries ORDER BY country");
while(($coid,$coname)=$sth->fetchrow)
{
	$coname=~s/APOSTROPHH/'/g;
	$country[$coid]=$coname;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($data{type} eq "exact")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT aid,status,email,password,agency,address,city,state,zip,phone,URL,country,price FROM cw_agencies WHERE $data{where}='$data{keyword}' ORDER BY agency");
	while(($aid,$status,$email,$password,$agency,$address,$city,$state,$zip,$phone,$url,$country,$realpayperday)=$sth->fetchrow)
	{
		$address=~s/APOSTROPHH/'/g;
		$city=~s/APOSTROPHH/'/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a></b></td></tr><tr><td><font size=2>Full address:</font></td><td><font size=2>$address, $city, $zip, $state, $country[$country]</font></td></tr><tr><td><font size=2>Phone:</font></td><td><font size=2>$phone</font></td></tr><tr><td><font size=2>Contact info:</font></td><td><font size=2><a href="$url" target="_blank">$url</a>, <a href="mailto:$email">$email</a></font></td></tr><tr><td><font size=2>Service price (per day):</font></td><td><font size=2>$realpayperday $currency</font></td></tr>\n~;
		if ($status==0)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agapps"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
		elsif ($status==1)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdiss"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Disable"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
		elsif ($status==2)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agenas"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Enable"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "subs")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT aid,status,email,password,agency,address,city,state,zip,phone,URL,country,price FROM cw_agencies WHERE $data{where} LIKE '%$data{keyword}%' ORDER BY agency");
	while(($aid,$status,$email,$password,$agency,$address,$city,$state,$zip,$phone,$url,$country,$realpayperday)=$sth->fetchrow)
	{
		$address=~s/APOSTROPHH/'/g;
		$city=~s/APOSTROPHH/'/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a></b></td></tr><tr><td><font size=2>Full address:</font></td><td><font size=2>$address, $city, $zip, $state, $country[$country]</font></td></tr><tr><td><font size=2>Phone:</font></td><td><font size=2>$phone</font></td></tr><tr><td><font size=2>Contact info:</font></td><td><font size=2><a href="$url" target="_blank">$url</a>, <a href="mailto:$email">$email</a></font></td></tr><tr><td><font size=2>Service price (per day):</font></td><td><font size=2>$realpayperday $currency</font></td></tr>\n~;
		if ($status==0)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agapps"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
		elsif ($status==1)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdiss"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Disable"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
		elsif ($status==2)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agenas"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Enable"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="agdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="aid" value="$aid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&agency;
}
sub agapps
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET status=1 WHERE aid=$data{aid}");
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency is approved\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is approved. Now you can login to members section from:\n";
	print MAIL "$cworld/members.html\n";
	print MAIL "Login: $uemail\n";
	print MAIL "Password: $pass\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&agsearch;
}
sub agdiss
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET status=2 WHERE aid=$data{aid}");
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency account is disabled\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is temporary disabled. Please, contact us to solve this problem.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&agsearch;
}
sub agenas
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET status=1 WHERE aid=$data{aid}");
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency account is enabled\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is enabled now.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&agsearch;
}
sub agdels
{
if ($data{aid})
{
	$selected{agency}="selected";
	&closedb;
	&methods;
	open (F,"<$cwpath/template/agrsconfirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&agsearch;
}
sub agdels_c
{
if ($data{aid})
{
	$sth=$dbh->query("LOCK TABLES cw_companies READ") if ($locktables);
	$sth=$dbh->query("SELECT cid FROM cw_companies WHERE aid=$data{aid}");
	@cid=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
	foreach(@cid)
	{
		$sth=$dbh->query("SELECT cpid FROM cw_coupons WHERE cid=$_");
		@temp=$sth->fetchcol;
		@cpid=(@cpid,@temp);
		$sth=$dbh->query("DELETE FROM cw_coupons WHERE cid=$_");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_stats WRITE,cw_books WRITE") if ($locktables);
	foreach(@cpid)
	{
		$sth=$dbh->query("DELETE FROM cw_stats WHERE cpid=$_");
		$sth=$dbh->query("DELETE FROM cw_books WHERE cpid=$_");
		unlink("$cwpath/coupons/$_.gif");
		unlink("$cwpath/coupons/$_.jpg");
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_companies WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM cw_companies WHERE aid=$data{aid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("SELECT email,password,agency FROM cw_agencies WHERE aid=$data{aid}");
	($uemail,$pass,$adagency)=$sth->fetchrow;
	$sth=$dbh->query("DELETE FROM cw_agencies WHERE aid=$data{aid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Your advertising agency account is removed\n\n";
	print MAIL $header;
	print MAIL "Advertising Agency: $adagency\n";
	print MAIL "Your account is removed from our system.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&agsearch;
}
sub coupon
{
$selected{coupon}="selected";
&closedb;
&methods;
open (F,"<$cwpath/template/coupon.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub cplist
{
$selected{coupon}="selected";
$type=$data{type};
$selectede{$type}="selected";
$sth=$dbh->query("LOCK TABLES cw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category FROM cw_categories");
while(($caid,$caname)=$sth->fetchrow)
{
	$caname=~s/APOSTROPHH/'/g;
	$category[$caid]=$caname;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($data{type} eq "all")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ,cw_coupons READ,cw_companies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_coupons.cpid,caid,title,qty,taken,paysts,sdate,edate,descr,cw_agencies.email,cw_agencies.password,cw_agencies.agency FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid) ORDER BY title");
	while(($cpid,$caid,$title,$qty,$taken,$paysts,$sdate,$edate,$descr,$email,$password,$agency)=$sth->fetchrow)
	{
		$title=~s/APOSTROPHH/'/g;
		$descr=~s/APOSTROPHH/'/g;
		$descr=~s/\n/<br>/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><font color=black>$title (belong to <a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a>)</font></b></td></tr><tr><td><font size=2>Coupon ID/Invoice #:</font></td><td><font size=2>$cpid</font></td></tr><tr><td><font size=2>Description:</font></td><td><font size=2>$descr</font></td></tr><tr><td><font size=2>Category:</font></td><td><font size=2>$category[$caid]</font></td></tr><tr><td><font size=2>Quantity:</font></td><td><font size=2>Quantity - $qty ; Taken - $taken</font></td></tr><tr><td><font size=2>Dates:</font></td><td><font size=2>From $sdate till $edate</font></td></tr>\n~;
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "napp")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ,cw_coupons READ,cw_companies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_coupons.cpid,caid,title,qty,taken,paysts,sdate,edate,descr,cw_agencies.email,cw_agencies.password,cw_agencies.agency FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid AND paysts=0) ORDER BY title");
	while(($cpid,$caid,$title,$qty,$taken,$paysts,$sdate,$edate,$descr,$email,$password,$agency)=$sth->fetchrow)
	{
		$title=~s/APOSTROPHH/'/g;
		$descr=~s/APOSTROPHH/'/g;
		$descr=~s/\n/<br>/g;
		$agency=~s/APOSTROPHH/'/g;
		if (-e "$cwpath/coupons/$cpid.gif")
		{
			$review="$cworld/coupons/$cpid.gif";
		}
		else
		{
			$review="$cworld/coupons/$cpid.jpg";
		}
		if ($couponmode==1)
		{
			$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><font color=black>$title (belong to <a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a>)</font></b></td></tr><tr><td><font size=2>Coupon ID/Invoice #:</font></td><td><font size=2>$cpid</font></td></tr><tr><td><font size=2>Description:</font></td><td><font size=2>$descr</font></td></tr><tr><td><font size=2>Category:</font></td><td><font size=2>$category[$caid]</font></td></tr><tr><td><font size=2>Quantity:</font></td><td><font size=2>Quantity - $qty ; Taken - $taken</font></td></tr><tr><td><font size=2>Dates:</font></td><td><font size=2>From $sdate till $edate</font></td></tr><tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpapp"><input type="hidden" name="type" value="$type"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdel"><input type="hidden" name="type" value="$type"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"> <a href="$review" target="_blank">View coupon</a></form></font></td></tr></table></td></tr>\n~;
		}
		else
		{
			$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><font color=black>$title (belong to <a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a>)</font></b></td></tr><tr><td><font size=2>Coupon ID/Invoice #:</font></td><td><font size=2>$cpid</font></td></tr><tr><td><font size=2>Description:</font></td><td><font size=2>$descr</font></td></tr><tr><td><font size=2>Category:</font></td><td><font size=2>$category[$caid]</font></td></tr><tr><td><font size=2>Quantity:</font></td><td><font size=2>Quantity - $qty ; Taken - $taken</font></td></tr><tr><td><font size=2>Dates:</font></td><td><font size=2>From $sdate till $edate</font></td></tr><tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpapp"><input type="hidden" name="type" value="$type"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdel"><input type="hidden" name="type" value="$type"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"> <a href="$review" target="_blank">View coupon logo</a></form></font></td></tr></table></td></tr>\n~;
		}
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{type} eq "app")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ,cw_coupons READ,cw_companies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_coupons.cpid,caid,title,qty,taken,paysts,sdate,edate,descr,cw_agencies.email,cw_agencies.password,cw_agencies.agency FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid AND paysts=1) ORDER BY title");
	while(($cpid,$caid,$title,$qty,$taken,$paysts,$sdate,$edate,$descr,$email,$password,$agency)=$sth->fetchrow)
	{
		$title=~s/APOSTROPHH/'/g;
		$descr=~s/APOSTROPHH/'/g;
		$descr=~s/\n/<br>/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><font color=black>$title (belong to <a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a>)</font></b></td></tr><tr><td><font size=2>Coupon ID/Invoice #:</font></td><td><font size=2>$cpid</font></td></tr><tr><td><font size=2>Description:</font></td><td><font size=2>$descr</font></td></tr><tr><td><font size=2>Category:</font></td><td><font size=2>$category[$caid]</font></td></tr><tr><td><font size=2>Quantity:</font></td><td><font size=2>Quantity - $qty ; Taken - $taken</font></td></tr><tr><td><font size=2>Dates:</font></td><td><font size=2>From $sdate till $edate</font></td></tr><tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdel"><input type="hidden" name="type" value="$type"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&coupon;
}
sub cpapp
{
if ($data{cpid})
{
	$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_coupons SET paysts=1 WHERE cpid=$data{cpid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_coupons,cw_companies,cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_agencies.email FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cpid=$data{cpid} AND cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid)");
	$uemail=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Coupon is approved\n\n";
	print MAIL $header;
	print MAIL "Coupon ID/Invoice #: $data{cpid}\n";
	print MAIL "Your coupon is approved by admin and added to rotation.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&cplist;
}
sub cpdel
{
if ($data{cpid})
{
	$selected{agency}="selected";
	&closedb;
	&methods;
	open (F,"<$cwpath/template/cprconfirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&cplist;
}
sub cpdel_c
{
if ($data{cpid})
{
	$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM cw_coupons WHERE cpid=$data{cpid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_stats WRITE,cw_books WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM cw_stats WHERE cpid=$data{cpid}");
	$sth=$dbh->query("DELETE FROM cw_books WHERE cpid=$data{cpid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	unlink("$cwpath/coupons/$data{cpid}.gif");
	unlink("$cwpath/coupons/$data{cpid}.jpg");
	$sth=$dbh->query("LOCK TABLES cw_coupons,cw_companies,cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_agencies.email FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cpid=$data{cpid} AND cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid)");
	$uemail=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Coupon is removed\n\n";
	print MAIL $header;
	print MAIL "Coupon ID/Invoice #: $data{cpid}\n";
	print MAIL "Coupon is removed from our system.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&cplist;
}
sub cpsearch
{
$selected{coupon}="selected";
$type=$data{type};
$selectede{$type}="selected";
$type=$data{where};
$selectedee{$type}="selected";
$sth=$dbh->query("LOCK TABLES cw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category FROM cw_categories");
while(($caid,$caname)=$sth->fetchrow)
{
	$caname=~s/APOSTROPHH/'/g;
	$category[$caid]=$caname;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($data{type} eq "exact")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ,cw_coupons READ,cw_companies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_coupons.cpid,caid,title,qty,taken,paysts,sdate,edate,descr,cw_agencies.email,cw_agencies.password,cw_agencies.agency FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid AND cw_coupons.$data{where}='$data{keyword}') ORDER BY title");
	while(($cpid,$caid,$title,$qty,$taken,$paysts,$sdate,$edate,$descr,$email,$password,$agency)=$sth->fetchrow)
	{
		$title=~s/APOSTROPHH/'/g;
		$descr=~s/APOSTROPHH/'/g;
		$descr=~s/\n/<br>/g;
		$agency=~s/APOSTROPHH/'/g;
		if (-e "$cwpath/coupons/$cpid.gif")
		{
			$review="$cworld/coupons/$cpid.gif";
		}
		else
		{
			$review="$cworld/coupons/$cpid.jpg";
		}
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><font color=black>$title (belong to <a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a>)</font></b></td></tr><tr><td><font size=2>Coupon ID/Invoice #:</font></td><td><font size=2>$cpid</font></td></tr><tr><td><font size=2>Description:</font></td><td><font size=2>$descr</font></td></tr><tr><td><font size=2>Category:</font></td><td><font size=2>$category[$caid]</font></td></tr><tr><td><font size=2>Quantity:</font></td><td><font size=2>Quantity - $qty ; Taken - $taken</font></td></tr><tr><td><font size=2>Dates:</font></td><td><font size=2>From $sdate till $edate</font></td></tr>\n~;
		if ($paysts==0)
		{
			if ($couponmode==1)
			{
				$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpapps"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"> <a href="$review" target="_blank">View coupon</a></form></font></td></tr></table></td></tr>\n~;
			}
			else
			{
				$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpapps"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"> <a href="$review" target="_blank">View coupon logo</a></form></font></td></tr></table></td></tr>\n~;
			}
		}
		elsif ($paysts==1)
		{
			if ($couponmode==1)
			{
				$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
			}
			else
			{
				$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
			}
		}
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
if ($data{type} eq "subs")
{
	$sth=$dbh->query("LOCK TABLES cw_agencies READ,cw_coupons READ,cw_companies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_coupons.cpid,caid,title,qty,taken,paysts,sdate,edate,descr,cw_agencies.email,cw_agencies.password,cw_agencies.agency FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid AND cw_coupons.$data{where} LIKE '%$data{keyword}%') ORDER BY title");
	while(($cpid,$caid,$title,$qty,$taken,$paysts,$sdate,$edate,$descr,$email,$password,$agency)=$sth->fetchrow)
	{
		$title=~s/APOSTROPHH/'/g;
		$descr=~s/APOSTROPHH/'/g;
		$descr=~s/\n/<br>/g;
		$agency=~s/APOSTROPHH/'/g;
		$res.=qq~<tr><td colspan=2 bgcolor=yellow><b><font color=black>$title (belong to <a href="$cgi/cwmember.pl?name=$email&password=$password" target="_blank"><font color=black>$agency</font></a>)</font></b></td></tr><tr><td><font size=2>Coupon ID/Invoice #:</font></td><td><font size=2>$cpid</font></td></tr><tr><td><font size=2>Description:</font></td><td><font size=2>$descr</font></td></tr><tr><td><font size=2>Category:</font></td><td><font size=2>$category[$caid]</font></td></tr><tr><td><font size=2>Quantity:</font></td><td><font size=2>Quantity - $qty ; Taken - $taken</font></td></tr><tr><td><font size=2>Dates:</font></td><td><font size=2>From $sdate till $edate</font></td></tr>\n~;
		if ($paysts==0)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpapps"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Approve"></form></font></td><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
		elsif ($paysts==1)
		{
			$res.=qq~<tr><td><font size=2>Operation:</font></td><td><table><tr><td><font size=2><form action="$cgi/cwadmin.pl" method="post"><input type="hidden" name="password" value="$data{password}"><input type="hidden" name="method" value="cpdels"><input type="hidden" name="where" value="$data{where}"><input type="hidden" name="keyword" value="$data{keyword}"><input type="hidden" name="type" value="$data{type}"><input type="hidden" name="cpid" value="$cpid"><input type=submit value="Delete"></form></font></td></tr></table></td></tr>\n~;
		}
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&coupon;
}
sub cpapps
{
if ($data{cpid})
{
	$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_coupons SET paysts=1 WHERE cpid=$data{cpid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_coupons,cw_companies,cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_agencies.email FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cpid=$data{cpid} AND cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid)");
	$uemail=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Coupon is approved\n\n";
	print MAIL $header;
	print MAIL "Coupon ID/Invoice #: $data{cpid}\n";
	print MAIL "Your coupon is approved by admin and added to rotation.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&cpsearch;
}
sub cpdels
{
if ($data{cpid})
{
	$selected{agency}="selected";
	&closedb;
	&methods;
	open (F,"<$cwpath/template/cprsconfirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
&cpsearch;
}
sub cpdels_c
{
if ($data{cpid})
{
	$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM cw_coupons WHERE cpid=$data{cpid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_stats WRITE,cw_books WRITE") if ($locktables);
	$sth=$dbh->query("DELETE FROM cw_stats WHERE cpid=$data{cpid}");
	$sth=$dbh->query("DELETE FROM cw_books WHERE cpid=$data{cpid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	unlink("$cwpath/coupons/$data{cpid}.gif");
	unlink("$cwpath/coupons/$data{cpid}.jpg");
	$sth=$dbh->query("LOCK TABLES cw_coupons,cw_companies,cw_agencies READ") if ($locktables);
	$sth=$dbh->query("SELECT cw_agencies.email FROM cw_coupons,cw_companies,cw_agencies WHERE (cw_coupons.cpid=$data{cpid} AND cw_coupons.cid=cw_companies.cid AND cw_companies.aid=cw_agencies.aid)");
	$uemail=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
	$sth=$dbh->query("SELECT header,footer FROM cw_settings");
	($header,$footer)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$header=~s/APOSTROPHH/'/g;
	$footer=~s/APOSTROPHH/'/g;
	open (MAIL,"|$progmail");
	print MAIL "To: $uemail\n";
	print MAIL "From: $email ($owntitle)\n";
	print MAIL "Subject: Coupon is removed\n\n";
	print MAIL $header;
	print MAIL "Coupon ID/Invoice #: $data{cpid}\n";
	print MAIL "Coupon is removed from our system.\n";
	print MAIL $footer;
	print MAIL "\n.\n";
	close (MAIL);
}
&cpsearch;
}
sub db
{
$selected{db}="selected";
$status.="Backup system status:<br>";
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
if (@files)
{
	($atime,$mtime)=(stat("$backuppath/$files[0]"))[8,9];
	($day,$month,$date,$time,$year)=split(" ",scalar localtime($mtime));
	$status.="Database was backed up on $date/$month/$year $time";
}
else
{
	$status.="Database wasnt backed up.";
}
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$data{sdate}=$date unless ($data{sdate});
$data{smonth}=$cal{$month} unless ($data{smonth});
$data{syear}=$year unless ($data{syear});
$i=1;
while ($i<32)
{
	$i_o=$i;
	$i_o="0$i_o" if (length($i_o)==1);
	if ($i==$data{sdate}){$sdates.="<option value=\"$i_o\" selected>$i_o</option>\n";}
	else{$sdates.="<option value=\"$i_o\">$i_o</option>\n";}
	$i++;
}
$i=1;
while ($i<13)
{
	$i_o=$i;
	$i_o="0$i_o" if (length($i_o)==1);
	if ($i==$data{smonth}){$smonthes.="<option value=\"$i_o\" selected>$cal[$i]</option>\n";}
	else{$smonthes.="<option value=\"$i_o\">$cal[$i]</option>\n";}
	$i++;
}
$i=$year;
while ($i<$year+10)
{
	if ($i==$data{syear}){$syears.="<option value=\"$i\" selected>$i</option>\n";}
	else{$syears.="<option value=\"$i\">$i</option>\n";}
	$i++;
}
&closedb;
&methods;
open (F,"<$cwpath/template/systools.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub backup_data
{
$sth=$dbh->query("LOCK TABLES cw_agencies WRITE, cw_companies WRITE, cw_coupons WRITE, cw_stats WRITE, cw_settings WRITE, cw_visitors WRITE, cw_coutries WRITE, cw_categories WRITE, cw_books WRITE, cw_cmfonts WRITE, cw_cmpics WRITE") if ($locktables);
$sth=$dbh->query("BACKUP TABLE cw_agencies,cw_companies,cw_coupons,cw_stats,cw_settings,cw_visitors,cw_coutries,cw_categories,cw_books,cw_cmfonts,cw_cmpics TO '$backuppath'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&db;
}
sub delete_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files)
{
	unlink("$backuppath/$_");
}
&db;
}
sub install_backup
{
opendir(Dir,"$backuppath");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
if(@files)
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE, cw_companies WRITE, cw_coupons WRITE, cw_stats WRITE, cw_settings WRITE, cw_visitors WRITE, cw_coutries WRITE, cw_categories WRITE, cw_books WRITE, cw_cmfonts WRITE, cw_cmpics WRITE") if ($locktables);
	$sth=$dbh->query("DROP TABLE cw_agencies,cw_companies,cw_coupons,cw_stats,cw_settings,cw_visitors,cw_coutries,cw_categories,cw_books,cw_cmfonts,cw_cmpics");
	$sth=$dbh->query("RESTORE TABLE cw_agencies,cw_companies,cw_coupons,cw_stats,cw_settings,cw_visitors,cw_coutries,cw_categories,cw_books,cw_cmfonts,cw_cmpics FROM '$backuppath'");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&db;
}
sub sql_dump
{
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_agencies");
while (($aid,$email,$password,$agency,$address,$city,$state,$zip,$phone,$URL,$country,$status,$price,$lastdate,$lastsip,$lastuip)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_agencies (aid,email,password,agency,address,city,state,zip,phone,URL,country,status,price,lastdate,lastsip,lastuip) VALUES ($aid,'$email','$password','$agency','$address','$city','$state','$zip','$phone','$URL',$country,$status,$price,'$lastdate','$lastsip','$lastuip');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_companies READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_companies");
while (($cid,$aid,$email,$company,$address,$city,$state,$zip,$phone,$URL,$country)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_companies (cid,aid,email,company,address,city,state,zip,phone,URL,country) VALUES ($cid,$aid,'$email','$company','$address','$city','$state','$zip','$phone','$URL',$country);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_coupons READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_coupons");
while (($cpid,$cid,$caid,$title,$limits,$qty,$taken,$width,$height,$paysts,$sdate,$edate,$descr)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_coupons (cpid,cid,caid,title,limits,qty,taken,width,height,paysts,sdate,edate,descr) VALUES ($cpid,$cid,$caid,'$title','$limits',$qty,$taken,$width,$height,$paysts,'$sdate','$edate','$descr');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_stats READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_stats");
while (($epid,$cpid,$sdate,$hits)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_stats (epid,cpid,sdate,hits) VALUES ($epid,$cpid,'$sdate',$hits);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_settings");
while (($header,$footer,$invoice)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_settings (header,footer,invoice) VALUES ('$header','$footer','$invoice');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_countries READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_countries");
while (($coid,$country)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_countries (coid,country) VALUES ($coid,'$country');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_categories");
while (($caid,$category,$descr)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_categories (caid,category,descr) VALUES ($caid,'$category','$descr');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_visitors READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_visitors");
while (($vid,$email,$name)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_visitors (vid,email,name) VALUES ($vid,'$email','$name');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_books READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_books");
while (($bid,$vid,$cpid,$indx)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_books (bid,vid,cpid,indx) VALUES ($bid,$vid,$cpid,$indx);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_cmfonts READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_cmfonts");
while (($fid,$file,$fontname)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_cmfonts (fid,file,fontname) VALUES ($fid,'$file','$fontname');\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_cmpics READ") if ($locktables);
$sth=$dbh->query("SELECT * FROM cw_cmpics");
while (($piid,$category,$file,$type,$width,$height)=$sth->fetchrow)
{
	$file.="INSERT INTO cw_cmpics (piid,category,file,type,width,height) VALUES ($piid,'$category','$file',$type,$width,$height);\n"
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-disposition: filename=\"cw_tables.sql\"; \n";
print "content-type: application/sqldump\n\n";
print $file;
exit;
}
sub reset_db
{
$selected{db}="selected";
&closedb;
&methods;
open (F,"<$cwpath/template/resetdb.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_db1
{
$sth=$dbh->query("LOCK TABLES cw_agencies WRITE, cw_companies WRITE, cw_coupons WRITE, cw_stats WRITE, cw_visitors WRITE, cw_books WRITE, cw_cmfonts WRITE, cw_cmpics WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM cw_agencies");
$sth=$dbh->query("DELETE FROM cw_companies");
$sth=$dbh->query("DELETE FROM cw_coupons");
$sth=$dbh->query("DELETE FROM cw_stats");
$sth=$dbh->query("DELETE FROM cw_visitors");
$sth=$dbh->query("DELETE FROM cw_books");
$sth=$dbh->query("DELETE FROM cw_cmfonts");
$sth=$dbh->query("DELETE FROM cw_cmpics");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
opendir(Dir,"$cwpath/coupons");
@files=readdir(Dir);
closedir(Dir);
shift(@files);
shift(@files);
foreach(@files){unlink("$cwpath/coupons/$_");}
&db;
}
sub reset_stats
{
$selected{db}="selected";
&closedb;
&methods;
open (F,"<$cwpath/template/clearold.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub reset_stats1
{
$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
$sth=$dbh->query("SELECT cpid FROM cw_coupons WHERE edate<'$data{syear}-$data{smonth}-$data{sdate}'");
@cpid=$sth->fetchcol;
$sth=$dbh->query("DELETE FROM cw_coupons WHERE edate<'$data{syear}-$data{smonth}-$data{sdate}'");
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_stats WRITE, cw_books WRITE") if ($locktables);
foreach(@cpid)
{
	$sth=$dbh->query("DELETE FROM cw_stats WHERE cpid=$_");
	$sth=$dbh->query("DELETE FROM cw_books WHERE cpid=$_");
	unlink("$cwpath/coupons/$_.gif");
	unlink("$cwpath/coupons/$_.jpg");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&db;
}
sub servprice
{
$selected{servprice}="selected";
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT aid,agency FROM cw_agencies ORDER BY agency");
while(($aid,$agency)=$sth->fetchrow)
{
	$agency=~s/APOSTROPHH/'/g;
	$agencies.=qq~<option value="$aid">$agency</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
&methods;
open (F,"<$cwpath/template/servprice.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub setprice
{
if ($data{aid} && $data{price}>=0)
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET price=$data{price} WHERE aid=$data{aid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
elsif ($data{price}>=0)
{
	$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_agencies SET price=$data{price}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&servprice;
}
sub cmconfig
{
$selected{cmconfig}="selected";
$sth=$dbh->query("LOCK TABLES cw_cmfonts READ") if ($locktables);
$sth=$dbh->query("SELECT fid,fontname FROM cw_cmfonts ORDER BY fontname");
while(($fid,$fontname)=$sth->fetchrow)
{
	$fontname=~s/APOSTROPHH/'/g;
	$ttf.=qq~<option value="$fid">$fontname</option>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
&methods;
open (F,"<$cwpath/template/cm_config.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub scanttf
{
opendir(Dir,"$cwpath/ttf");
@fonts=readdir(Dir);
closedir(Dir);
shift(@fonts);
shift(@fonts);
$sth=$dbh->query("LOCK TABLES cw_cmfonts WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM cw_cmfonts");
foreach(@fonts)
{
	$sth=$dbh->query("INSERT INTO cw_cmfonts (file,fontname) VALUES ('$cwpath/ttf/$_','$_')");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&cmconfig;
}
sub activate_fonts
{
opendir(Dir,"$cwpath/fonts");
@clips=readdir(Dir);
closedir(Dir);
shift(@clips);
shift(@clips);
foreach(@clips){unlink ("$cwpath/fonts/$_");}
$useim='use Image::Magick;';
eval "$useim";
$image = Image::Magick->new;
@fonts=$image->QueryFont();
undef $image;
$i=0;
while ($i<@fonts)
{
	$image = Image::Magick->new;
	$image->Set(size=>"80x20");
	$image->Set(type=>"TrueColor");
	$image->ReadImage("xc:white");
	$x=$image->Annotate(text=>'AaBbCc',font=>"$fonts[$i]",fill=>'black',pointsize=>'18',gravity=>'Center');
	unless ($x=~/ 415\:/)
	{
		$image->Write(filename=>"$cwpath/fonts/$fonts[$i].jpg", compression=>'None');
	}
	undef $image;
	$i++;
}
$sth=$dbh->query("LOCK TABLES cw_cmfonts READ") if ($locktables);
$sth=$dbh->query("SELECT file,fontname FROM cw_cmfonts");
while(($file,$fontname)=$sth->fetchrow)
{
	$fontname=~s/APOSTROPHH/'/g;
	$fontname=~s/ /-/g;
	$image = Image::Magick->new;
	$image->Set(size=>"80x20");
	$image->Set(type=>"TrueColor");
	$image->ReadImage("xc:white");
	$x=$image->Annotate(text=>'AaBbCc',font=>"$file",fill=>'black',pointsize=>'18',gravity=>'Center');
	unless ($x=~/ 415\:/)
	{
		$image->Write(filename=>"$cwpath/fonts/$fontname.jpg", compression=>'None');
	}
	undef $image;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&cmconfig;
}
sub rename_font
{
if ($data{newname} && $data{fid})
{
	$data{newname}=~s/'/APOSTROPHH/g;
	$sth=$dbh->query("LOCK TABLES cw_cmfonts WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_cmfonts SET fontname='$data{newname}' WHERE fid=$data{fid}");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
&cmconfig;
}
sub index_clipart
{
$useim='use Image::Magick;';
eval "$useim";
opendir(Dir,"$cwpath/clipart");
@dirs=readdir(Dir);
closedir(Dir);
shift(@dirs);
shift(@dirs);
foreach(@dirs)
{
	unless (-d "$cwpath/clipart_th/$_")
	{
		mkdir "$cwpath/clipart_th/$_",0777;
		chmod 0777,"$cwpath/clipart_th/$_";
	}
}
$sth=$dbh->query("LOCK TABLES cw_cmpics WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM cw_cmpics WHERE type=1");
foreach $dir(@dirs)
{
	if (-d "$cwpath/clipart/$dir")
	{
		opendir(Dir,"$cwpath/clipart/$dir");
		@files=readdir(Dir);
		closedir(Dir);
		shift(@files);
		shift(@files);
		foreach $file(@files)
		{
			if (-f "$cwpath/clipart/$dir/$file" && $file=~/\.jpg$/i)
			{
				$image = Image::Magick->new;
				$image->ReadImage("$cwpath/clipart/$dir/$file");
				($width,$height)=$image->Get('width','height');
				if ($width && $height)
				{
					$clipart_th_height=int($clipart_th_width/$width*$height);
					$image->Set(quality=>'100');
					$image->Resize(width=>"$clipart_th_width",height=>"$clipart_th_height",filter=>'Cubic');
					$image->Write(filename=>"$cwpath/clipart_th/$dir/$file", compression=>'None');
					$sth=$dbh->query("INSERT INTO cw_cmpics (category,file,type,width,height) VALUES ('$dir','$file',1,$width,$height)");
				}
				undef $image;
			}
		}
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&cmconfig;
}
sub index_tmpl
{
$useim='use Image::Magick;';
eval "$useim";
opendir(Dir,"$cwpath/tmpl");
@dirs=readdir(Dir);
closedir(Dir);
shift(@dirs);
shift(@dirs);
foreach(@dirs)
{
	unless (-d "$cwpath/tmpl_th/$_")
	{
		mkdir "$cwpath/tmpl_th/$_",0777;
		chmod 0777,"$cwpath/tmpl_th/$_";
	}
}
$sth=$dbh->query("LOCK TABLES cw_cmpics WRITE") if ($locktables);
$sth=$dbh->query("DELETE FROM cw_cmpics WHERE type=2");
foreach $dir(@dirs)
{
	if (-d "$cwpath/tmpl/$dir")
	{
		opendir(Dir,"$cwpath/tmpl/$dir");
		@files=readdir(Dir);
		closedir(Dir);
		shift(@files);
		shift(@files);
		foreach $file(@files)
		{
			if (-f "$cwpath/tmpl/$dir/$file" && $file=~/\.jpg$/i)
			{
				$image = Image::Magick->new;
				$image->ReadImage("$cwpath/tmpl/$dir/$file");
				($width,$height)=$image->Get('width','height');
				if ($width && $height)
				{
					$tmpl_th_height=int($tmpl_th_width/$width*$height);
					$image->Set(quality=>'100');
					$image->Resize(width=>"$tmpl_th_width",height=>"$tmpl_th_height",filter=>'Cubic');
					$image->Write(filename=>"$cwpath/tmpl_th/$dir/$file", compression=>'None');
					$sth=$dbh->query("INSERT INTO cw_cmpics (category,file,type,width,height) VALUES ('$dir','$file',2,$width,$height)");
				}
				undef $image;
			}
		}
	}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&cmconfig;
}
sub closedb
{
$sth="";
$dbh="";
}
sub methods
{
$methods=qq~
<option value="genset" $selected{genset}>General Settings</option>
<option value="category" $selected{category}>Categories</option>
<option value="stats" $selected{stats}>General Stats</option>
<option value="agency" $selected{agency}>Agencies</option>
<option value="coupon" $selected{coupon}>Coupons</option>
<option value="servprice" $selected{servprice}>Service price</option>
<option value="db" $selected{db}>DB management</option>
<option value="maillist" $selected{maillist}>Mailing List</option>
~;
$methods.=qq~<option value="cmconfig" $selected{cmconfig}>CM module</option>\n~ if ($usecm);
}
