#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

($day,$month,$date,$time,$year)=split(" ",scalar localtime);	
$month=$cal{$month};
$today="$year-$month-$date";
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
if (!$cookie{email})
{
	&closedb;
	open (F,"<$cwpath/template/register2.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES cw_visitors READ") if ($locktables);
$sth=$dbh->query("SELECT vid FROM cw_visitors WHERE email='$cookie{email}'");
$vid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($vid)
{
	&closedb;
	open (F,"<$cwpath/template/register2.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES cw_books READ") if ($locktables);
$sth=$dbh->query("SELECT cpid FROM cw_books WHERE vid=$vid");
@cpid=$sth->fetchcol;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_coupons READ, cw_companies READ, cw_countries READ") if ($locktables);
foreach(@cpid)
{
	$sth=$dbh->query("SELECT cpid,width,height,cw_companies.company,cw_companies.address,cw_companies.city,cw_companies.zip,cw_companies.state,cw_countries.country,cw_companies.URL,title,edate,limits,descr FROM cw_coupons,cw_companies,cw_countries WHERE (paysts=1 AND cpid=$_ AND sdate<='$today' AND edate>='$today' AND cw_coupons.cid=cw_companies.cid AND cw_companies.country=cw_countries.coid)");
	($cpid,$width,$height,$company,$address,$city,$zip,$state,$country,$uurl,$title,$edate,$limits,$descr)=$sth->fetchrow;
	$uurl=$uurl || "Not defined";
	$uurl="http://$uurl" unless ($uurl=~/^http\:\/\//);
	$company=~s/APOSTROPHH/'/g;
	$title=~s/APOSTROPHH/'/g;
	$limits=~s/APOSTROPHH/'/g;
	$address=~s/APOSTROPHH/'/g;
	$descr=~s/APOSTROPHH/'/g;
	$descr=~s/\n/<br>/g;
	($year,$month,$date)=split("-",$edate);
	$month=$cal[$month];
	$height+=200;
	$differ=$width-$logowidth;
	if ($differ<150)
	{
		$width=$logowidth+150;
	}
	$width+=30;
	$res.=qq~<tr><td bgcolor=yellow width=450 valign="top"><font color=black><b>$title</b></font></td><td align=center bgcolor=yellow width=100 valign=top><a href="Javascript:printout('$cpid','$width','$height')"><img src="$cworld/images/but8.gif" border=0></a></td></tr><tr><td colspan=2><font size=1><b>COMPANY:</b> $company<br><b>COMPANY ADDRESS:</b> $address, $city, $zip, $state, $country<br><b>EXPIRATION DATE:</b> $month $date $year<br><b>LIMITS:</b> $limits<br><b>URL:</b> <a href="$uurl" target="_blank">$uurl</a><br><b>DESCRIPTION:</b> $descr<br><a href="$cgi/cwdelc.pl?$cpid">Delete from book</a></font></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$cwpath/template/couponbook.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
sub closedb
{
$sth="";
$dbh="";
}
