#!/usr/bin/perl
use Image::Magick;
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT aid,status,price FROM cw_agencies WHERE (email='$data{name}' AND password='$data{password}')");
($aid,$status,$realpayperday)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$destination=$data{method};
$destination="initial" unless ($destination);
&$destination if ($aid && $status==1);
if (!$aid)
{
	$errauth="Error: Wrong login name or password";
}
elsif ($status==2)
{
	$errauth="Error: Your account is temporary disabled";
}
else
{
	$errauth="Error: Your account is not approved yet. Try again later";
}
&closedb;
&methods;
open (F,"<$cwpath/template/errauth.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
sub initial
{
	unlink("$cwpath/cm/$aid.tmp.jpg");
	unlink("$cwpath/cm/$aid.jpg");
	$sth=$dbh->query("LOCK TABLES cw_cmpics READ") if ($locktables);
	$sth=$dbh->query("SELECT count(*) FROM cw_cmpics WHERE type=2");
	$total=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$addoption=qq~<option value="choose_template">Pre-made template ($total units)</option>~ if ($total);
	&closedb;
	open (F,"<$cwpath/template/cm_initial.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub choose_template
{
	$sth=$dbh->query("LOCK TABLES cw_cmpics READ") if ($locktables);
	$sth=$dbh->query("SELECT DISTINCT category FROM cw_cmpics WHERE type=2");
	@categories=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&initial unless (@categories);
	$data{category}=$categories[0] unless ($data{category});
	foreach(@categories)
	{
		if ($_ eq $data{category})
		{
			$categories.=qq~<option value="$_" selected>$_</option>\n~;
		}
		else
		{
			$categories.=qq~<option value="$_">$_</option>\n~;
		}
	}
	$sth=$dbh->query("LOCK TABLES cw_cmpics READ") if ($locktables);
	$sth=$dbh->query("SELECT piid,file,width,height FROM cw_cmpics WHERE (type=2 AND category='$data{category}')");
	$i=0;
	while (($piid,$file,$width,$height)=$sth->fetchrow)
	{
		$templates.=qq~<tr>~ if ($i==0);
		$templates.=qq~<td align=center valign=top><font size=2>Size: $width x $height<br><img src="$cworld/tmpl_th/$data{category}/$file"><br><input type=radio name=template value="$piid"></td>\n~;
		$i++;
		if ($i==2){$i=0;$templates.=qq~</tr>~;}
	}
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	$templates.=qq~<td>&nbsp;</td></tr>~ if ($i==1);
	$templates.=qq~<tr><td align="center" colspan=2><input type="submit" value="Proceed"></td></tr>~ if ($templates);
	&closedb;
	open (F,"<$cwpath/template/cm_template.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub confirm_template
{
	&choose_template unless ($data{template});
	$sth=$dbh->query("LOCK TABLES cw_cmpics READ") if ($locktables);
	$sth=$dbh->query("SELECT category,file FROM cw_cmpics WHERE piid=$data{template}");
	($category,$file)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&choose_template if (!$category || !$file);
	open (F,"$cwpath/tmpl/$category/$file");
	binmode F;
	@file=<F>;
	close(F);
	open (F,">$cwpath/cm/$aid.jpg");
	binmode F;
	print F @file;
	close(F);
	&main_menu;
}
sub create_new
{
	opendir(Dir,"$cwpath/textures");
	@files=readdir(Dir);
	closedir(Dir);
	shift(@files);
	shift(@files);
	@files=sort(@files);
	foreach(@files)
	{
		if ($_=~/\.gif$/ || $_=~/\.jpg$/)
		{
			$first=$_ unless ($first);
			($name)=split(/\./,$_);
			$textures.=qq~<option value="$_">$name</option>\n~;
		}
	}
	&closedb;
	open (F,"<$cwpath/template/cm_new.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub create_new_final
{
	$data{backcolor}=$data{custom_backcolor} if ($data{custom_backcolor});
	$data{transparency_color}=$data{custom_transparency_color} if ($data{custom_transparency_color});
	$data{bordercolor}=$data{custom_bordercolor} if ($data{custom_bordercolor});
	$data{backcolor}=~s/[^A-Fa-f0-9]+//g;
	$data{transparency_color}=~s/[^A-Fa-f0-9]+//g;
	$data{bordercolor}=~s/[^A-Fa-f0-9]+//g;
	if (length($data{backcolor})!=6 && $data{background} eq "color")
	{
		$error=qq~<tr><td><font color=white size=2>Error: background color has incorrect format</font></td></tr>~;
		&create_new;
	}
	if ((length($data{backcolor})!=6 || length($data{transparency_color})!=6) && $data{background} eq "gradient")
	{
		$error=qq~<tr><td><font color=white size=2>Error: start or end gradient color has incorrect format</font></td></tr>~;
		&create_new;
	}
	if (length($data{bordercolor})!=6 && ($data{useborder}==1 || $data{useborder}==2))
	{
		$error=qq~<tr><td><font color=white size=2>Error: border color has incorrect format</font></td></tr>~;
		&create_new;
	}
	if (!$data{texture} && $data{background} eq "texture")
	{
		$error=qq~<tr><td><font color=white size=2>Error: unknown texture</font></td></tr>~;
		&create_new;
	}
	$data{width}=~s/\D+//g;
	$data{height}=~s/\D+//g;
	$data{bsize}=~s/\D+//g;
	if (!$data{width} || $data{width}<20 || $data{width}>$maxwidth)
	{
		$error=qq~<tr><td><font color=white size=2>Error: coupon width should be 20-$maxwidth pixels</font></td></tr>~;
		&create_new;
	}
	if (!$data{height} || $data{height}<20 || $data{height}>$maxheight)
	{
		$error=qq~<tr><td><font color=white size=2>Error: coupon height should be 20-$maxheight pixels</font></td></tr>~;
		&create_new;
	}
	if ((!$data{bsize} || $data{bsize}<1 || $data{bsize}>int($data{width}/2)) && ($data{useborder}==1 || $data{useborder}==2))
	{
		$error=qq~<tr><td><font color=white size=2>Error: border size is incorrect</font></td></tr>~;
		&create_new;
	}
	($data{texture})=split(/\./,$data{texture});
	$data{backcolor}="#$data{backcolor}";
	$data{transparency_color}="#$data{transparency_color}";
	$data{bordercolor}="#$data{bordercolor}";
	if ($data{useborder}==1 || $data{useborder}==2)
	{
		$data{width}-=$data{bsize}*2;
		$data{height}-=$data{bsize}*2;
	}
	$image = Image::Magick->new;
	$image->Set(size=>"$data{width}x$data{height}");
	$image->Set(type=>"TrueColor");
	if ($data{background} eq "color")
	{
		$image->ReadImage("xc:$data{backcolor}");
	}
	elsif ($data{background} eq "gradient")
	{
		$image->ReadImage("gradient:$data{backcolor}-$data{transparency_color}");
	}
	else
	{
		if (-e "$cwpath/textures/$data{texture}.jpg")
		{
			$image->ReadImage("tile:$cwpath/textures/$data{texture}.jpg");
		}
		elsif (-e "$cwpath/textures/$data{texture}.gif")
		{
			$image->ReadImage("tile:$cwpath/textures/$data{texture}.gif");
		}
	}
	if ($data{useborder})
	{
		if ($data{useborder}==1)
		{
			$image->Border(width=>$data{bsize},height=>$data{bsize},fill=>"$data{bordercolor}");
		}
		elsif ($data{useborder}==2)
		{
			$outer=int($data{bsize}/4*3);
			$image->Frame(width=>$data{bsize},height=>$data{bsize},outer=>$outer,fill=>"$data{bordercolor}");
		}
		elsif ($data{useborder}==3)
		{
			$image->Raise(width=>$data{bsize},height=>$data{bsize},raise=>'True');
		}
		elsif ($data{useborder}==4)
		{
			$image->Raise(width=>$data{bsize},height=>$data{bsize},raise=>'False');
		}
	}
	$image->Set(quality=>'100');
	$image->Write(filename=>"$cwpath/cm/$aid.tmp.jpg", compression=>'None');
	$confirm_method="confirm_changes";
	$discard_method="initial";
	&closedb;
	srand;
	$random=int(rand(99999999));
	open (F,"<$cwpath/template/cm_new_confirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub confirm_changes
{
	rename("$cwpath/cm/$aid.tmp.jpg","$cwpath/cm/$aid.jpg");
	&main_menu;
}
sub main_menu
{
	srand;
	$random=int(rand(99999999));
	$sth=$dbh->query("LOCK TABLES cw_cmpics READ") if ($locktables);
	$sth=$dbh->query("SELECT DISTINCT category FROM cw_cmpics WHERE type=1");
	@categories=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach(@categories){$categories.=qq~<option value="$_">$_</option>~;}
	$image = Image::Magick->new;
	@fonts=$image->QueryFont();
	$sth=$dbh->query("LOCK TABLES cw_cmfonts READ") if ($locktables);
	$sth=$dbh->query("SELECT fontname FROM cw_cmfonts");
	@fontname=$sth->fetchcol;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	foreach(@fontname){$_=~s/APOSTROPHH/'/g;$_=~s/ /-/g;}
	@fonts=(@fonts,@fontname);
	@fonts=sort(@fonts);
	foreach(@fonts)
	{
		if (-e "$cwpath/fonts/$_.jpg")
		{
			$fname=$_;
			$fname=~s/\-/ /g;
			$fonts.=qq~<option value="$_">$fname</option>~;
			$firstfont="$cworld/fonts/$_.jpg" unless ($firstfont);
		}
	}
	&closedb;
	open (F,"<$cwpath/template/cm_main.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub addtext
{
	if ($data{text})
	{
		$data{text}=~s/\r//g;
		$data{strokewidth}=~s/\D+//g;
		$data{strokecolor}="None" unless ($data{strokewidth});
		$data{fontsize}=~s/\D+//g;
		$data{fontsize}=10 unless ($data{fontsize});
		$data{coor_x}=~s/\D+//g;
		$data{xoor_x}=0 unless ($data{coor_x});
		$data{coor_y}=~s/\D+//g;
		$data{xoor_y}=20 unless ($data{coor_y});
		($scalexi,$scalexd)=split(/\./,$data{scale_x});
		$scalexi=~s/\D+//g;
		$scalexi=0 unless ($scalexi);
		$scalexd=~s/\D+//g;
		$scalexd=0 unless ($scalexd);
		if (!$scalexi && !$scalexd)
		{
			$data{scale_x}="1.0";
		}
		else
		{
			$data{scale_x}="$scalexi.$scalexd";
		}
		($scaleyi,$scaleyd)=split(/\./,$data{scale_y});
		$scaleyi=~s/\D+//g;
		$scaleyi=0 unless ($scaleyi);
		$scaleyd=~s/\D+//g;
		$scaleyd=0 unless ($scaleyd);
		if (!$scaleyi && !$scaleyd)
		{
			$data{scale_y}="1.0";
		}
		else
		{
			$data{scale_y}="$scaleyi.$scaleyd";
		}
		($skewxi,$skewxd)=split(/\./,$data{skew_x});
		$skewxi=~s/\D+//g;
		$skewxi=0 unless ($skewxi);
		$skewxd=~s/\D+//g;
		$skewxd=0 unless ($skewxd);
		$data{skew_x}="$skewxi.$skewxd";
		($skewyi,$skewyd)=split(/\./,$data{skew_y});
		$skewyi=~s/\D+//g;
		$skewyi=0 unless ($skewyi);
		$skewyd=~s/\D+//g;
		$skewyd=0 unless ($skewyd);
		$data{skew_y}="$skewyi.$skewyd";
		($rotatei,$rotated)=split(/\./,$data{rotate});
		$rotatei=~s/\D+//g;
		$rotatei=0 unless ($rotatei);
		$rotated=~s/\D+//g;
		$rotated=0 unless ($rotated);
		$data{rotate}="$rotatei.$rotated";
		$data{fontcolor}=~s/[^A-Fa-f0-9]+//g;
		$data{strokecolor}=~s/[^A-Fa-f0-9]+//g if ($data{strokecolor} ne "None");
		$data{undercolor}=~s/[^A-Fa-f0-9]+//g;
		if (length($data{fontcolor})!=6)
		{
			$data{fontcolor}="FFFFFF";
		}
		if (length($data{strokecolor})!=6 && $data{strokewidth})
		{
			$data{strokecolor}="FFFFFF";
		}
		if (length($data{undercolor})!=6 && $data{undercolor})
		{
			$data{undercolor}="000000";
		}
		$fontface=$data{fontface};
		$fontface=~s/-/ /g;
		$fontface=~s/'/APOSTROPHH/g;
		$sth=$dbh->query("LOCK TABLES cw_cmfonts READ") if ($locktables);
		$sth=$dbh->query("SELECT file FROM cw_cmfonts WHERE fontname='$fontface'");
		$file=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		$data{fontface}=$file if ($file);
		$image = Image::Magick->new;
		$image->ReadImage("$cwpath/cm/$aid.jpg");
		$image->Set(quality=>'100');
		if ($data{undercolor})
		{
			$image->Annotate(text=>"$data{text}",font=>"$data{fontface}",fill=>"#$data{fontcolor}",pointsize=>"$data{fontsize}",geometry=>"+$data{coor_x}+$data{coor_y}",gravity=>'NorthWest',strokewidth=>"$data{strokewidth}",stroke=>"#$data{strokecolor}",skewX=>"$data{skew_x}",skewY=>"$data{skew_y}",scale=>"$data{scale_x}, $data{scale_y}",rotate=>"$data{rotate}",undercolor=>"#$data{undercolor}");
		}
		else
		{
			$image->Annotate(text=>"$data{text}",font=>"$data{fontface}",fill=>"#$data{fontcolor}",pointsize=>"$data{fontsize}",geometry=>"+$data{coor_x}+$data{coor_y}",gravity=>'NorthWest',strokewidth=>"$data{strokewidth}",stroke=>"#$data{strokecolor}",skewX=>"$data{skew_x}",skewY=>"$data{skew_y}",scale=>"$data{scale_x}, $data{scale_y}",rotate=>"$data{rotate}");
		}
		$image->Write(filename=>"$cwpath/cm/$aid.tmp.jpg", compression=>'None');
		$confirm_method="confirm_changes";
		$discard_method="main_menu";
		&closedb;
		srand;
		$random=int(rand(99999999));
		open (F,"<$cwpath/template/cm_new_confirm.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("",@htmlpage);
		$htmlpage="print qq~$htmlpage~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
		exit;
	}
	&main_menu;
}
sub addgraphics
{
	if ($data{piid})
	{
		$sth=$dbh->query("LOCK TABLES cw_cmpics READ") if ($locktables);
		$sth=$dbh->query("SELECT category,file FROM cw_cmpics WHERE (type=1 AND piid=$data{piid})");
		($category,$file)=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		&main_menu if (!$file || !$category);
		$data{coor_x}=~s/\D+//g;
		$data{xoor_x}=0 unless ($data{coor_x});
		$data{coor_y}=~s/\D+//g;
		$data{xoor_y}=20 unless ($data{coor_y});
		$image = Image::Magick->new;
		$image->ReadImage("$cwpath/cm/$aid.jpg");
		$image->Set(quality=>'100');
		$image2 = Image::Magick->new;
		$image2->ReadImage("$cwpath/clipart/$category/$file");
		$image2->Set(quality=>'100');
		$image->Composite(image=>$image2,x=>"$data{coor_x}",y=>"$data{coor_y}");
		undef $image2;
		$image->Write(filename=>"$cwpath/cm/$aid.tmp.jpg", compression=>'None');
		$confirm_method="confirm_changes";
		$discard_method="main_menu";
		&closedb;
		srand;
		$random=int(rand(99999999));
		open (F,"<$cwpath/template/cm_new_confirm.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("",@htmlpage);
		$htmlpage="print qq~$htmlpage~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
		exit;
	}
	&main_menu;
}
sub enchance
{
	$image = Image::Magick->new;
	$image->ReadImage("$cwpath/cm/$aid.jpg");
	$image->Set(quality=>'100');
	if ($data{enchancement} eq "spiff")
	{
		$image->Contrast(sharpen=>'true');
	}
	elsif ($data{enchancement} eq "dull")
	{
		$image->Contrast(sharpen=>'false');
	}
	elsif ($data{enchancement} eq "equalize")
	{
		$image->Equalize();
	}
	elsif ($data{enchancement} eq "normalize")
	{
		$image->Normalize();
	}
	elsif ($data{enchancement} eq "negate")
	{
		$image->Negate();
	}
	elsif ($data{enchancement} eq "hue")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{parameter}="$parami.$paramd";
		$image->Modulate(hue=>"$data{parameter}");
	}
	elsif ($data{enchancement} eq "saturation")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{parameter}="$parami.$paramd";
		$image->Modulate(saturation=>"$data{parameter}");
	}
	elsif ($data{enchancement} eq "brightness")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{parameter}="$parami.$paramd";
		$image->Modulate(brightness=>"$data{parameter}");
	}
	elsif ($data{enchancement} eq "gamma")
	{
		$image->Gamma(gamma=>"$data{parameter}");
	}
	elsif ($data{enchancement} eq "level")
	{
		$image->Level(level=>"$data{parameter}");
	}
	$image->Write(filename=>"$cwpath/cm/$aid.tmp.jpg", compression=>'None');
	$confirm_method="confirm_changes";
	$discard_method="main_menu";
	&closedb;
	srand;
	$random=int(rand(99999999));
	open (F,"<$cwpath/template/cm_new_confirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub effects
{
	$image = Image::Magick->new;
	$image->ReadImage("$cwpath/cm/$aid.jpg");
	$image->Set(quality=>'100');
	if ($data{effect} eq "sharpen")
	{
		($parami,$paramd)=split(/\./,$data{radius});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{radius}="$parami.$paramd";
		($parami,$paramd)=split(/\./,$data{sigma});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{sigma}="$parami.$paramd";
		$image->Sharpen(radius=>"$data{radius}",sigma=>"$data{sigma}");
	}
	elsif ($data{effect} eq "blur")
	{
		($parami,$paramd)=split(/\./,$data{radius});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{radius}="$parami.$paramd";
		($parami,$paramd)=split(/\./,$data{sigma});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{sigma}="$parami.$paramd";
		$image->Blur(radius=>"$data{radius}",sigma=>"$data{sigma}");
	}
	elsif ($data{effect} eq "despeckle")
	{
		$image->Despeckle();
	}
	elsif ($data{effect} eq "emboss")
	{
		($parami,$paramd)=split(/\./,$data{radius});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{radius}="$parami.$paramd";
		($parami,$paramd)=split(/\./,$data{sigma});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{sigma}="$parami.$paramd";
		$image->Emboss(radius=>"$data{radius}",sigma=>"$data{sigma}");
	}
	elsif ($data{effect} eq "threshold")
	{
		($parami,$paramd)=split(/\./,$data{amount});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$data{amount}=$parami;
		$image->Threshold("$data{amount}");
	}
	elsif ($data{effect} eq "spread")
	{
		($parami,$paramd)=split(/\./,$data{amount});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$data{amount}=$parami;
		$image->Spread("$data{amount}");
	}
	elsif ($data{effect} eq "shade")
	{
		($parami,$paramd)=split(/\./,$data{azimuth});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{azimuth}="$parami.$paramd";
		$image->Shade(azimuth=>"$data{azimuth}",color=>"$data{elevation}");
	}
	elsif ($data{effect} eq "edge")
	{
		($parami,$paramd)=split(/\./,$data{radius});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{radius}="$parami.$paramd";
		$image->Edge(radius=>"$data{radius}");
	}
	elsif ($data{effect} eq "medianfilter")
	{
		($parami,$paramd)=split(/\./,$data{radius});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{radius}="$parami.$paramd";
		$image->MedianFilter(radius=>"$data{radius}");
	}
	elsif ($data{effect} eq "reducenoise")
	{
		($parami,$paramd)=split(/\./,$data{radius});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{radius}="$parami.$paramd";
		$image->ReduceNoise("$data{radius}");
	}
	elsif ($data{effect} eq "emboss")
	{
		($parami,$paramd)=split(/\./,$data{radius});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{radius}="$parami.$paramd";
		($parami,$paramd)=split(/\./,$data{sigma});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{sigma}="$parami.$paramd";
		($parami,$paramd)=split(/\./,$data{amount});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{amount}="$parami.$paramd";
		$image->MotionBlur(radius=>"$data{radius}",sigma=>"$data{sigma}",angle=>"$data{amount}");
	}
	$image->Write(filename=>"$cwpath/cm/$aid.tmp.jpg", compression=>'None');
	$confirm_method="confirm_changes";
	$discard_method="main_menu";
	&closedb;
	srand;
	$random=int(rand(99999999));
	open (F,"<$cwpath/template/cm_new_confirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub fx
{
	$image = Image::Magick->new;
	$image->ReadImage("$cwpath/cm/$aid.jpg");
	$image->Set(quality=>'100');
	if ($data{fx} eq "charcoal")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$data{parameter}=$parami;
		$image->Charcoal("$data{parameter}");
	}
	elsif ($data{fx} eq "implode")
	{
		$image->Implode("$data{parameter}");
	}
	elsif ($data{fx} eq "oilpaint")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$data{parameter}=$parami;
		$image->OilPaint(radius=>"$data{parameter}");
	}
	elsif ($data{fx} eq "solarize")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$data{parameter}=$parami;
		$image->Solarize("$data{parameter}");
	}
	elsif ($data{fx} eq "stegano")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$data{parameter}=$parami;
		$digi=$image->Clone();
		$image->Stegano(image=>$digi,offset=>"$data{parameter}");
		undef $digi;
	}
	elsif ($data{fx} eq "stereo")
	{
		$stereo=$image->Clone();
		$stereo->Roll('+4+4');
		$image->Stereo(image=>$stereo);
		undef $stereo;
	}
	elsif ($data{fx} eq "swirl")
	{
		($parami,$paramd)=split(/\./,$data{parameter});
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$data{parameter}="$parami.$paramd";
		$image->Swirl(degrees=>"$data{parameter}");
	}
	elsif ($data{fx} eq "wave")
	{
		($amplitude,$wavelength)=split(/\//,$data{parameter});
		($parami,$paramd)=split(/\./,$amplitude);
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$amplitude="$parami.$paramd";
		($parami,$paramd)=split(/\./,$wavelength);
		$parami=~s/\D+//g;
		$parami=0 unless ($parami);
		$paramd=~s/\D+//g;
		$paramd=0 unless ($paramd);
		$wavelength="$parami.$paramd";
		$image->Wave(amplitude=>"$amplitude",wavelength=>"$wavelength");
	}
	$image->Write(filename=>"$cwpath/cm/$aid.tmp.jpg", compression=>'None');
	$confirm_method="confirm_changes";
	$discard_method="main_menu";
	&closedb;
	srand;
	$random=int(rand(99999999));
	open (F,"<$cwpath/template/cm_new_confirm.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub finalize
{
if ($data{cpid})
{
	$sth=$dbh->query("LOCK TABLES cw_coupons READ") if ($locktables);
	$sth=$dbh->query("SELECT cid FROM cw_coupons WHERE cpid=$data{cpid}");
	$cid=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if ($cid)
	{
		$sth=$dbh->query("LOCK TABLES cw_companies READ") if ($locktables);
		$sth=$dbh->query("SELECT aid FROM cw_companies WHERE cid=$cid");
		$aaid=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		if ($aaid==$aid)
		{
			rename("$cwpath/cm/$aid.jpg","$cwpath/coupons/$data{cpid}.jpg");
			$image = Image::Magick->new;
			$image->ReadImage("$cwpath/coupons/$data{cpid}.jpg");
			($width,$height)=$image->Get('width','height');
			$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
			$sth=$dbh->query("UPDATE cw_coupons SET width=$width,height=$height WHERE cpid=$data{cpid}");
			$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
			$data{fontface}=$file if ($file);
			&closedb;
			&methods;
			$error="<tr><td valign=top><font size=2 color=white><b>SUCCESS:</b></font></td><td><font size=2 color=white>Your coupon has been moved to rotation.</font></td></tr>";
			open (F,"<$cwpath/template/cm_final.tpl");
			@htmlpage=<F>;
			close (F);
			$htmlpage=join("",@htmlpage);
			$htmlpage="print qq~$htmlpage~;";
			print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
			print "content-type: text/html\n\n";
			eval $htmlpage;
			exit;
		}
		else
		{
			$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>This coupon is not belong to you. You cant upload coupon.</font></td></tr>";
			&closedb;
			&methods;
			open (F,"<$cwpath/template/cm_final.tpl");
			@htmlpage=<F>;
			close (F);
			$htmlpage=join("",@htmlpage);
			$htmlpage="print qq~$htmlpage~;";
			print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
			print "content-type: text/html\n\n";
			eval $htmlpage;
			exit;
		}
	}
	else
	{
		$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>This coupon is not exist in our database</font></td></tr>";
		&closedb;
		&methods;
		open (F,"<$cwpath/template/cm_final.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("",@htmlpage);
		$htmlpage="print qq~$htmlpage~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
		exit;
	}
}
else
{
	$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>Unknown coupon ID</font></td></tr>";
	&closedb;
	&methods;
	open (F,"<$cwpath/template/cm_final.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
}
sub closedb
{
$sth="";
$dbh="";
undef $image;
}
sub methods
{
$methods=qq~
<option value="geninfo" $selected{geninfo}>General Information</option>
<option value="company" $selected{company}>Companies</option>
<option value="add_coupon" $selected{add_coupon}>Add new coupon</option>
<option value="man_coupon" $selected{man_coupon}>Manage coupons</option>
<option value="reupload_graphic" $selected{reupload_graphic}>Reupload graphics</option>
<option value="advert" $selected{advert}>Info for advertisers</option>
~;
}
