#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

($day,$month,$date,$time,$year)=split(" ",scalar localtime);	
$month=$cal{$month};
$today="$year-$month-$date";
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
@data=split("&",$ENV{QUERY_STRING});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
if (!$cookie{email})
{
	&closedb;
	open (F,"<$cwpath/template/register.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES cw_visitors READ") if ($locktables);
$sth=$dbh->query("SELECT vid FROM cw_visitors WHERE email='$cookie{email}'");
$vid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($vid)
{
	&closedb;
	open (F,"<$cwpath/template/register.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if ($cookie{num})
{
$sth=$dbh->query("LOCK TABLES cw_coupons READ, cw_companies READ, cw_countries READ") if ($locktables);
$sth=$dbh->query("SELECT cpid,width,height,cw_companies.company,cw_companies.address,cw_companies.city,cw_companies.zip,cw_companies.state,cw_countries.country,cw_companies.URL,cw_coupons.title,cw_coupons.limits,cw_coupons.edate,cw_coupons.descr FROM cw_coupons,cw_companies,cw_countries WHERE (paysts=1 AND cpid=$cookie{num} AND sdate<='$today' AND edate>='$today' AND cw_coupons.cid=cw_companies.cid AND cw_companies.country=cw_countries.coid)");
($cpid,$width,$height,$company,$address,$city,$zip,$state,$country,$uurl,$title,$limits,$edate,$descr)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$company=~s/APOSTROPHH/'/g;
$address=~s/APOSTROPHH/'/g;
$uurl=$uurl || "Not defined";
$uurl="http://$uurl" unless ($uurl=~/^http\:\/\//);
$title=~s/APOSTROPHH/'/g;
$limits=~s/APOSTROPHH/'/g;
$descr=~s/APOSTROPHH/'/g;
$descr=~s/\n/<br>/g;
($year,$month,$date)=split("-",$edate);
$month=$cal[$month];
$vheight=$height;
$vwidth=$width;
$differ=$vwidth-$logowidth;
if ($differ<150)
{
	$vwidth=$logowidth+150;
}
$wider=$logowidth+5;
if ($cpid)
{
	$sth=$dbh->query("LOCK TABLES cw_books READ") if ($locktables);
	$sth=$dbh->query("SELECT indx FROM cw_books WHERE (vid=$vid AND cpid=$cpid)");
	$indx=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	&closedb;
	if (-e "$cwpath/coupons/$cpid.gif")
	{
		$couponname="$cworld/coupons/$cpid.gif";
	}
	else
	{
		$couponname="$cworld/coupons/$cpid.jpg";
	}
	if ($couponmode==1)
	{
		open (F,"<$cwpath/template/cform.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("",@htmlpage);
		$htmlpage="print qq~$htmlpage~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
	}
	else
	{
		open (F,"<$cwpath/template/cform2.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("",@htmlpage);
		$htmlpage="print qq~$htmlpage~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
	}
	exit;
}
else
{
	&closedb;
	open (F,"<$cwpath/template/unknownerr.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
}
else
{
	&closedb;
	open (F,"<$cwpath/template/unknownerr.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
sub closedb
{
$sth="";
$dbh="";
}
