package paypal;
use Time::Local;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

require Exporter;
@ISA = qw( Exporter );
@EXPORT = qw(
		ccpayment
	    );
open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

sub ccpayment
{
%data=@_;
if ($data{cid} && $data{cpid})
{
	$realpayperday=$data{realpayperday};
	$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
	$sth=$dbh->query("LOCK TABLES cw_coupons READ") if ($locktables);
	$sth=$dbh->query("SELECT sdate,edate FROM cw_coupons WHERE (cid=$data{cid} AND cpid=$data{cpid})");
	($sdate,$edate)=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if ($sdate && $edate)
	{
	($syear,$smonth,$sdate)=split("-",$sdate);
	($eyear,$emonth,$edate)=split("-",$edate);
	$payment=(timelocal(0,0,0,$edate,$emonth-1,$eyear)-timelocal(0,0,0,$sdate,$smonth-1,$syear))/86400*$realpayperday+$realpayperday;
	$payment=sprintf("%.2f",$payment);
	$taxpay=$payment/100*$tax;
	$taxpay=sprintf("%.2f",$taxpay);
	$total=$payment+$taxpay;
	$total=sprintf("%.2f",$total);
	$sth="";
	$dbh="";
	open (F,"<$cwpath/template/paypal_payment.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;   	
	}
	else
	{
	open (F,"<$cwpath/template/paypal_error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;   	
	}
}
else
{
	open (F,"<$cwpath/template/paypal_error.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;   	
}
}
1;
