#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

($ldate=scalar localtime)=~s/ \d+:\d+:\d+//;
($day,$date,$month,$time,$year)=split(" ",scalar localtime);
@data=split("&",$ENV{QUERY_STRING});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
@data=split("; ",$ENV{HTTP_COOKIE});
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex ($1))/eg;
		$cookie{$field}=$value;
	}
}
$num=$cookie{num};
$num=~s/\D+//g;
unless ($num)
{
	&closedb;
	open (F,"<$cwpath/template/unknownerr.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
if (!$cookie{email})
{
	&closedb;
	open (F,"<$cwpath/template/register.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
($day,$month,$date,$time,$year)=split(" ",scalar localtime);	
$month=$cal{$month};
$today="$year-$month-$date";
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
$sth=$dbh->query("LOCK TABLES cw_visitors READ") if ($locktables);
$sth=$dbh->query("SELECT vid FROM cw_visitors WHERE email='$cookie{email}'");
$vid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($vid)
{
	&closedb;
	open (F,"<$cwpath/template/register.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES cw_books READ") if ($locktables);
$sth=$dbh->query("SELECT vid FROM cw_books WHERE (vid=$vid AND cpid=$num)");
$bid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($bid)
{
	&closedb;
	open (F,"<$cwpath/template/alreadyhave.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
$sth=$dbh->query("SELECT cpid,taken FROM cw_coupons WHERE (paysts=1 AND sdate<='$today' AND edate>='$today' AND taken<qty AND cpid=$num)");
($cpid,$taken)=$sth->fetchrow;
if ($cpid)
{
	$taken++;
	$sth=$dbh->query("UPDATE cw_coupons SET taken=$taken WHERE (paysts=1 AND sdate<='$today' AND edate>='$today' AND taken<qty AND cpid=$num)");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($cpid)
{
$sth=$dbh->query("LOCK TABLES cw_books WRITE, cw_stats WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO cw_books (vid,cpid,indx) VALUES ($vid,$num,$taken)");
$sth=$dbh->query("SELECT epid,hits FROM cw_stats WHERE (cpid=$num AND sdate='$today')");
($epid,$hits)=$sth->fetchrow;
if ($epid)
{
	$hits++;
	$sth=$dbh->query("UPDATE cw_stats SET hits=$hits WHERE cpid=$num");
}
else
{
	$sth=$dbh->query("INSERT INTO cw_stats (cpid,sdate,hits) VALUES ($num,'$today',1)");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$cwpath/template/addtobook.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
else
{
&closedb;
open (F,"<$cwpath/template/nocoupon.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
