#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
if (!$data{method}){&initial;}
else {$dest=$data{method};&$dest;}

sub initial
{
$sth=$dbh->query("LOCK TABLES cw_countries READ") if ($locktables);
$sth=$dbh->query("SELECT coid,country FROM cw_countries ORDER BY country");
while(($coid,$country)=$sth->fetchrow){$countries.="<option value=\"$coid\">$country</option>\n";}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
$error="ERRORS:<br>$error" if ($error);
open (F,"<$cwpath/template/join.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub register
{
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT aid FROM cw_agencies WHERE email='$data{email}'");
$aid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
if ($aid)
{
	$error.="Agency with same email address already registered<br>";
	$errflag=1;
}
$data{adagency}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT aid FROM cw_agencies WHERE agency='$data{adagency}'");
$aid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$data{adagency}=~s/APOSTROPHH/'/g;
if ($aid)
{
	$error.="Agency with same name already registered<br>";
	$errflag=1;
}
if (!$data{adagency})
{
	$error.="Advertising Agency field cant be empty<br>";
	$errflag=1;
}
if (!$data{address})
{
	$error.="Address field cant be empty<br>";
	$errflag=1;
}
if (!$data{city})
{
	$error.="City field cant be empty<br>";
	$errflag=1;
}
if (!$data{state})
{
	$error.="State / Province field cant be empty<br>";
	$errflag=1;
}
if (!$data{zip})
{
	$error.="Zip / Postal code field cant be empty<br>";
	$errflag=1;
}
if (!$data{country})
{
	$error.="Country field is empty, possible problem with DB connection. Please contact <a href=\"mailto:$email\">administrator</a><br>";
	$errflag=1;
}
if (!$data{phone})
{
	$error.="Phone field cant be empty<br>";
	$errflag=1;
}
if (!$data{email})
{
	$error.="Email field cant be empty<br>";
	$errflag=1;
}
unless ($data{email}=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $data{email}=~/^\w+/ && $data{email}=~/\w+$/)
{
	$error.="Incorrect email address<br>";
	$errflag=1;
}
&initial if ($errflag);
srand;
$password=int(rand(99999999));
$data{adagency}=~s/'/APOSTROPHH/g;
$data{address}=~s/'/APOSTROPHH/g;
$sth=$dbh->query("LOCK TABLES cw_agencies WRITE") if ($locktables);
$sth=$dbh->query("INSERT INTO cw_agencies (email,password,agency,address,city,state,zip,phone,URL,country,status,price) VALUES ('$data{email}','$password','$data{adagency}','$data{address}','$data{city}','$data{state}','$data{zip}','$data{phone}','$data{url}',$data{country},$autoaccept,$payperday)");
$sth=$dbh->query("SELECT LAST_INSERT_ID()");
$aid=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
unless ($aid)
{
	$error="Cant register your company data with database. Please contact <a href=\"mailto:$email\">administrator</a><br>";
	$data{adagency}=~s/APOSTROPHH/'/g;
	$data{address}=~s/APOSTROPHH/'/g;
	&initial;
}
$sth=$dbh->query("LOCK TABLES cw_settings READ") if ($locktables);
$sth=$dbh->query("SELECT header,footer FROM cw_settings");
($header,$footer)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_countries READ") if ($locktables);
$sth=$dbh->query("SELECT country FROM cw_countries WHERE coid=$data{country}");
$country=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$header=~s/APOSTROPHH/'/g;
$footer=~s/APOSTROPHH/'/g;
if ($autoaccept)
{
open (MAIL,"|$progmail");
print MAIL "To: $email\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: New advertising agency is registered\n\n";
print MAIL $header;
print MAIL "Advertising Agency: $data{adagency}\n";
print MAIL "Address: $data{address}\n";
print MAIL "City: $data{city}\n";
print MAIL "Zip: $data{zip}\n";
print MAIL "State: $data{state}\n";
print MAIL "Country: $country\n";
print MAIL "Email: $data{email}\n";
print MAIL "URL: $data{url}\n\n";
print MAIL $footer;
print MAIL "\n.\n";
close (MAIL);
open (MAIL,"|$progmail");
print MAIL "To: $data{email}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Registration information (important)\n\n";
print MAIL $header;
print MAIL "Advertising Agency: $data{adagency}\n";
print MAIL "Your agency is registered. Now you can login to Agencies section:\n$cworld/members.html\nLogin: $data{email}\nPassword: $password\n\n";
print MAIL $footer;
print MAIL "\n.\n";
close (MAIL);
}
else
{
open (MAIL,"|$progmail");
print MAIL "To: $email\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: New advertising agency is registered - confirmation required\n\n";
print MAIL $header;
print MAIL "Advertising Agency: $data{adagency}\n";
print MAIL "Address: $data{address}\n";
print MAIL "City: $data{city}\n";
print MAIL "Zip: $data{zip}\n";
print MAIL "State: $data{state}\n";
print MAIL "Country: $country\n";
print MAIL "Email: $data{email}\n";
print MAIL "URL: $data{url}\n\n";
print MAIL "Please accept or reject this agency from admin section\n";
print MAIL $footer;
print MAIL "\n.\n";
close (MAIL);
open (MAIL,"|$progmail");
print MAIL "To: $data{email}\n";
print MAIL "From: $email ($owntitle)\n";
print MAIL "Subject: Registration information (important)\n\n";
print MAIL $header;
print MAIL "Advertising Agency: $data{adagency}\n";
print MAIL "Your agency is registered. Please wait until your account is approved by admin. Then you can login to Agencies section:\n$cworld/members.html\nLogin: $data{email}\nPassword: $password\n\n";
print MAIL $footer;
print MAIL "\n.\n";
close (MAIL);
}
&closedb;
open (F,"<$cwpath/template/registered.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
