#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
if (!$data{email} || !$data{name})
{
	$err="Fill all fields please";
	&closedb;
	open (F,"<$cwpath/template/register2.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
unless ($data{email}=~/^[\w\-.]+\@{1}[\w\-.]+$/ && $data{email}=~/^\w+/ && $data{email}=~/\w+$/)
{
	$err="Incorrect email format";
	&closedb;
	open (F,"<$cwpath/template/register2.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
$sth=$dbh->query("LOCK TABLES cw_visitors WRITE") if ($locktables);
$sth=$dbh->query("SELECT vid FROM cw_visitors WHERE email='$data{email}'");
$vid=$sth->fetchrow;
unless ($vid)
{
	$sth=$dbh->query("INSERT INTO cw_visitors (email,name) VALUES ('$data{email}','$data{name}')");
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$year++;
$year=substr($year,2,2);
print "HTTP/1.0 302 Not Found\n" if ($sysid eq "Windows");
print "set-cookie: email=$data{email}; expires=Mon, 31-Dec-$year 23:59:59 GMT; \n";
print "Location: $cgi/cwbook.pl\n\n";

sub closedb
{
$sth="";
$dbh="";
}
