#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}

if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$keyword=$data{keyword};
$keyword=~s/'/APOSTROPHH/g;
@keyword=split(" ",$keyword);
foreach (@keyword){$_="(title LIKE '\%$_\%' OR descr LIKE '\%$_\%')";}
$keyword=join(" AND ",@keyword);
unless ($keyword)
{
	print "HTTP/1.0 302 Not Found\n" if ($sysid eq "Windows");
	print "Location: $cworld\n\n";
	exit;
}
($day,$month,$date,$time,$year)=split(" ",scalar localtime);	
$month=$cal{$month};
$today="$year-$month-$date";
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);
$sth=$dbh->query("LOCK TABLES cw_coupons READ, cw_companies READ, cw_countries READ") if ($locktables);
$sth=$dbh->query("SELECT cpid,cw_companies.company,cw_companies.address,cw_companies.city,cw_companies.zip,cw_companies.state,cw_countries.country,cw_companies.URL,title,edate,limits,descr FROM cw_coupons,cw_companies,cw_countries WHERE (paysts=1 AND sdate<='$today' AND edate>='$today' AND taken<qty AND cw_coupons.cid=cw_companies.cid AND cw_companies.country=cw_countries.coid AND $keyword) ORDER BY title");
while (($cpid,$company,$address,$city,$zip,$state,$country,$uurl,$title,$edate,$limits,$descr)=$sth->fetchrow)
{
	$uurl=$uurl || "Not defined";
	$company=~s/APOSTROPHH/'/g;
	$title=~s/APOSTROPHH/'/g;
	$limits=~s/APOSTROPHH/'/g;
	$address=~s/APOSTROPHH/'/g;
	$descr=~s/APOSTROPHH/'/g;
	$descr=~s/\n/<br>/g;
	($year,$month,$date)=split("-",$edate);
	$month=$cal[$month];
	$res.=qq~<tr><td bgcolor=yellow width=450 valign="top"><font color=black><b>$title</b></font></td><td align=center bgcolor=yellow width=100 valign=top><a href="Javascript:addtobook('$cpid')"><img src="$cworld/images/but5.gif" border=0></a></td></tr><tr><td colspan=2><font size=1><b>COMPANY:</b> $company<br><b>COMPANY ADDRESS:</b> $address, $city, $zip, $state, $country<br><b>EXPIRATION DATE:</b> $month $date $year<br><b>LIMITS:</b> $limits<br><b>URL:</b> <a href="$uurl" target="_blank">$uurl</a><br><b>DESCRIPTION:</b> $descr</font></td></tr>\n~;
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
open (F,"<$cwpath/template/search.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
sub closedb
{
$sth="";
$dbh="";
}
