#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

if ($ENV{CONTENT_LENGTH}>0){sysread(STDIN,$data,$ENV{CONTENT_LENGTH});}
else {($data=$ENV{QUERY_STRING});}
@data=split("&",$data);
foreach (@data)
{
	/([^=]+)=(.*)/ && do
	{
		($field,$value)=($1,$2);
		$value=~s/\+/ /g;
		$value=~s/%([0-9a-fA-F]{2})/pack('C',hex($1))/eg;
		$data{$field}=$value;
	}
}
$destination=$data{method};
$destination="total" unless ($destination);

$sth=$dbh->query("LOCK TABLES cw_coupons READ") if ($locktables);
$sth=$dbh->query("SELECT cpid,paysts,sdate,edate,qty,title,taken FROM cw_coupons WHERE (cpid=$data{cpid} AND cid=$data{cid})");
($cpid,$paysts,$sdate,$edate,$qty,$title,$taken)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&$destination if ($cpid);
&closedb;
print "HTTP/1.0 302 Not Found\n" if ($sysid eq "Windows");
print "Location: $cworld\n\n";
eval $htmlpage;
exit;

sub total
{
$selected{total}="selected";
($syear,$smonth,$sdate)=split("-",$sdate);
($eyear,$emonth,$edate)=split("-",$edate);
$unused=$qty-$taken;
$title=~s/APOSTROPHH/'/g;
if ($paysts==1)
{
	$paysts="Approved";
}
else
{
	$paysts="Not approved";
}
&closedb;
&methods;
open (F,"<$cwpath/template/total.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub detailed
{
$selected{detailed}="selected";
$sth=$dbh->query("LOCK TABLES cw_stats READ") if ($locktables);
$sth=$dbh->query("SELECT sdate,hits FROM cw_stats WHERE cpid=$data{cpid} ORDER BY sdate");
while (($sdate,$hits)=$sth->fetchrow)
{
	($year,$month,$date)=split("-",$sdate);
	$res.="<tr><td><font size=2 color=white>$date/$month/$year</font></td><td align=right><font size=2 color=white>$hits</font></td></tr>\n";
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&closedb;
&methods;
open (F,"<$cwpath/template/detailed.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
sub methods
{
$methods=qq~
<option value="total" $selected{total}>Total stats</option>
<option value="detailed" $selected{detailed}>Detailed stats</option>
~;
}
