#!/usr/bin/perl
use Mysql;

#    CouponWorld SQL v1.3 - coupons management software
#    Copyright (C) 1998-2010  T&D Systems, Inc.
#    http://www.td-systems.com/
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

open (F, "<cworld.cfg");
@commands=<F>;
close (F);
foreach (@commands)
{
	eval $_;
}
if ($usecm)
{
	$module="use Image::Magick;";
	eval $module;
}
$dbh=Mysql->connect($mysqlhost,$mysqldb,$mysqllogin,$mysqlpassword);

binmode STDIN;
read (STDIN,$buf,$ENV{CONTENT_LENGTH});
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$pdate="$month $date $year";

($boundary)=$ENV{CONTENT_TYPE}=~/boundary="([^"]+)"/; #";
($boundary)=$ENV{CONTENT_TYPE}=~/boundary=(\S+)/ unless $boundary;
$boundary="--".$boundary;
@file=split("\r\n$boundary",$buf);
foreach (@file)
{
	s/\r\n\r\n/delimeter/;
}
($field,$cpid)=split("delimeter",$file[0]);
($field,$data{name})=split("delimeter",$file[1]);
($field,$data{password})=split("delimeter",$file[2]);
($field,$file)=split("delimeter",$file[3]);
$sth=$dbh->query("LOCK TABLES cw_agencies READ") if ($locktables);
$sth=$dbh->query("SELECT aid,status FROM cw_agencies WHERE (email='$data{name}' AND password='$data{password}')");
($aid,$status)=$sth->fetchrow;
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
&process if ($aid && $status==1);
if (!$aid)
{
	$errauth="Error: Wrong login name or password";
}
elsif ($status==2)
{
	$errauth="Error: Your account is temporary disabled";
}
else
{
	$errauth="Error: Your account is not approved yet. Try again later";
}
&closedb;
&methods;
open (F,"<$cwpath/template/errauth.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
sub process
{
if ($cpid)
{
	$sth=$dbh->query("LOCK TABLES cw_coupons READ") if ($locktables);
	$sth=$dbh->query("SELECT cid FROM cw_coupons WHERE cpid=$cpid");
	$cid=$sth->fetchrow;
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
	if ($cid)
	{
		$sth=$dbh->query("LOCK TABLES cw_companies READ") if ($locktables);
		$sth=$dbh->query("SELECT aid FROM cw_companies WHERE cid=$cid");
		$aaid=$sth->fetchrow;
		$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
		if ($aaid==$aid)
		{
			if ($file=~/^GIF/)
			{
				open (F,">$cwpath/coupons/$cpid.gif");
				flock(F,$LOCK_EX);
				binmode F;
				print F $file;
				flock(F,$LOCK_UN);
				close (F);
				if (-e "$cwpath/coupons/$cpid.gif")
				{
					if ($usecm)
					{
						$image = Image::Magick->new;
						$image->ReadImage("$cwpath/coupons/$cpid.gif");
						($coup_width,$coup_height)=$image->Get('width','height');
						undef $image;
						$coup_width=0 unless ($coup_width);
						$coup_height=0 unless ($coup_height);
						unless ($coup_width)
						{
							$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>You cant use animated GIF as coupon</font></td></tr>";
							&closedb;
							&methods;
							open (F,"<$cwpath/template/upload.tpl");
							@htmlpage=<F>;
							close (F);
							$htmlpage=join("",@htmlpage);
							$htmlpage="print qq~$htmlpage~;";
							print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
							print "content-type: text/html\n\n";
							eval $htmlpage;
							exit;
						}
					}
					&add_coupon;
				}
				$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>Cant write file to coupons directory. Please, contact <a href=\"mailto:$email\">administrator</a></font></td></tr>";
				&closedb;
				&methods;
				open (F,"<$cwpath/template/upload.tpl");
				@htmlpage=<F>;
				close (F);
				$htmlpage=join("",@htmlpage);
				$htmlpage="print qq~$htmlpage~;";
				print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
				print "content-type: text/html\n\n";
				eval $htmlpage;
				exit;
			}
			elsif ($file=~/JFIF/)
			{
				open (F,">$cwpath/coupons/$cpid.jpg");
				flock(F,$LOCK_EX);
				binmode F;
				print F $file;
				flock(F,$LOCK_UN);
				close (F);
				if (-e "$cwpath/coupons/$cpid.jpg")
				{
					if ($usecm)
					{
						$image = Image::Magick->new;
						$image->ReadImage("$cwpath/coupons/$cpid.jpg");
						($coup_width,$coup_height)=$image->Get('width','height');
						undef $image;
						$coup_width=0 unless ($coup_width);
						$coup_height=0 unless ($coup_height);
					}
					&add_coupon;
				}
				$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>Cant write file to coupons directory. Please, contact <a href=\"mailto:$email\">administrator</a></font></td></tr>";
				&closedb;
				&methods;
				open (F,"<$cwpath/template/upload.tpl");
				@htmlpage=<F>;
				close (F);
				$htmlpage=join("",@htmlpage);
				$htmlpage="print qq~$htmlpage~;";
				print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
				print "content-type: text/html\n\n";
				eval $htmlpage;
				exit;
			}
			else
			{
				$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>Please, use only GIF or JPG files</font></td></tr>";
				&closedb;
				&methods;
				open (F,"<$cwpath/template/upload.tpl");
				@htmlpage=<F>;
				close (F);
				$htmlpage=join("",@htmlpage);
				$htmlpage="print qq~$htmlpage~;";
				print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
				print "content-type: text/html\n\n";
				eval $htmlpage;
				exit;
			}
		}
		else
		{
			$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>This coupon is not belong to you. You cant upload coupon.</font></td></tr>";
			&closedb;
			&methods;
			open (F,"<$cwpath/template/upload.tpl");
			@htmlpage=<F>;
			close (F);
			$htmlpage=join("",@htmlpage);
			$htmlpage="print qq~$htmlpage~;";
			print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
			print "content-type: text/html\n\n";
			eval $htmlpage;
			exit;
		}
	}
	else
	{
		$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>This coupon is not exist in our database</font></td></tr>";
		&closedb;
		&methods;
		open (F,"<$cwpath/template/upload.tpl");
		@htmlpage=<F>;
		close (F);
		$htmlpage=join("",@htmlpage);
		$htmlpage="print qq~$htmlpage~;";
		print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
		print "content-type: text/html\n\n";
		eval $htmlpage;
		exit;
	}
}
else
{
	$error="<tr><td valign=top><font size=2 color=white><b>ERROR:</b></font></td><td><font size=2 color=white>Unknown coupon ID</font></td></tr>";
	&closedb;
	&methods;
	open (F,"<$cwpath/template/upload.tpl");
	@htmlpage=<F>;
	close (F);
	$htmlpage=join("",@htmlpage);
	$htmlpage="print qq~$htmlpage~;";
	print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
	print "content-type: text/html\n\n";
	eval $htmlpage;
	exit;
}
}
sub add_coupon
{
$selected{add_coupon}="selected";
if ($usecm)
{
	$sth=$dbh->query("LOCK TABLES cw_coupons WRITE") if ($locktables);
	$sth=$dbh->query("UPDATE cw_coupons SET width=$coup_width, height=$coup_height WHERE cpid=$cpid");
	$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
}
$sth=$dbh->query("LOCK TABLES cw_companies READ") if ($locktables);
$sth=$dbh->query("SELECT cid,company FROM cw_companies WHERE aid=$aid ORDER BY company");
while(($cid,$company)=$sth->fetchrow)
{
	$company=~s/APOSTROPHH/'/g;
	if ($cid==$data{company}){$companies.="<option value=\"$cid\" selected>$company</option>\n";}
	else{$companies.="<option value=\"$cid\">$company</option>\n";}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$sth=$dbh->query("LOCK TABLES cw_categories READ") if ($locktables);
$sth=$dbh->query("SELECT caid,category FROM cw_categories ORDER BY category");
while(($caid,$category)=$sth->fetchrow)
{
	$category=~s/APOSTROPHH/'/g;
	if ($caid==$data{category}){$categories.="<option value=\"$caid\" selected>$category</option>\n";}
	else{$categories.="<option value=\"$caid\">$category</option>\n";}
}
$sth=$dbh->query("UNLOCK TABLES") if ($locktables);
$error="<tr><td valign=top><font size=2 color=white><b>SUCCESS:</b></font></td><td><font size=2 color=white>Your graphic coupon was uploaded successfully. Please wait for admin approval before it appears in rotation.</font></td></tr>";
($day,$month,$date,$time,$year)=split(" ",scalar localtime);
$data{sdate}=$date unless ($data{sdate});
$data{smonth}=$cal{$month} unless ($data{smonth});
$data{syear}=$year unless ($data{syear});
$data{edate}=$date unless ($data{edate});
$data{emonth}=$cal{$month} unless ($data{emonth});
$data{eyear}=$year unless ($data{eyear});
$i=1;
while ($i<32)
{
	$i_o=$i;
	$i_o="0$i_o" if (length($i_o)==1);
	if ($i==$data{edate}){$edates.="<option value=\"$i_o\" selected>$i_o</option>\n";}
	else{$edates.="<option value=\"$i_o\">$i_o</option>\n";}
	if ($i==$data{sdate}){$sdates.="<option value=\"$i_o\" selected>$i_o</option>\n";}
	else{$sdates.="<option value=\"$i_o\">$i_o</option>\n";}
	$i++;
}
$i=1;
while ($i<13)
{
	$i_o=$i;
	$i_o="0$i_o" if (length($i_o)==1);
	if ($i==$data{emonth}){$emonthes.="<option value=\"$i_o\" selected>$cal[$i]</option>\n";}
	else{$emonthes.="<option value=\"$i_o\">$cal[$i]</option>\n";}
	if ($i==$data{smonth}){$smonthes.="<option value=\"$i_o\" selected>$cal[$i]</option>\n";}
	else{$smonthes.="<option value=\"$i_o\">$cal[$i]</option>\n";}
	$i++;
}
$i=$year;
while ($i<$year+10)
{
	if ($i==$data{eyear}){$eyears.="<option value=\"$i\" selected>$i</option>\n";}
	else{$eyears.="<option value=\"$i\">$i</option>\n";}
	if ($i==$data{syear}){$syears.="<option value=\"$i\" selected>$i</option>\n";}
	else{$syears.="<option value=\"$i\">$i</option>\n";}
	$i++;
}
&closedb;
&methods;
open (F,"<$cwpath/template/addcoupon.tpl");
@htmlpage=<F>;
close (F);
$htmlpage=join("",@htmlpage);
$htmlpage="print qq~$htmlpage~;";
print "HTTP/1.0 200 Found\n" if ($sysid eq "Windows");
print "content-type: text/html\n\n";
eval $htmlpage;
exit;
}
sub closedb
{
$sth="";
$dbh="";
}
sub methods
{
$methods=qq~
<option value="geninfo" $selected{geninfo}>General Information</option>
<option value="company" $selected{company}>Companies</option>
<option value="add_coupon" $selected{add_coupon}>Add new coupon</option>
<option value="man_coupon" $selected{man_coupon}>Manage coupons</option>
<option value="reupload_graphic" $selected{reupload_graphics}>Reupload graphics</option>
<option value="advert" $selected{advert}>Info for advertisers</option>
~;
}
